'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const PluginManager = require('./PluginManager-c210aae0.js');
const logger = require('./logger-599e0d99.js');

/*
 *   Copyright 2022-2025 SenX S.A.S.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */
class PluginDef {
    constructor(def) {
        this.type = def.type;
        this.name = def.name;
        this.tag = def.tag;
        this.author = def.author;
        this.description = def.description;
        this.version = def.version;
        this.scriptWrapper = def.scriptWrapper;
    }
    toString() {
        return `${this.name}:${this.version} by ${this.author}`;
    }
}

/*
 *   Copyright 2022  SenX S.A.S.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */
window.global = window;

exports.CHART_TYPES = PluginManager.CHART_TYPES;
exports.ChartBounds = PluginManager.ChartBounds;
exports.ColorLib = PluginManager.ColorLib;
Object.defineProperty(exports, 'Colors', {
    enumerable: true,
    get: function () {
        return PluginManager.Colors;
    }
});
exports.Dashboard = PluginManager.Dashboard;
exports.DataModel = PluginManager.DataModel;
exports.Dataset = PluginManager.Dataset;
exports.DiscoveryEvent = PluginManager.DiscoveryEvent;
exports.GTS = PluginManager.GTS;
exports.GTSLib = PluginManager.GTSLib;
Object.defineProperty(exports, 'HeatMaps', {
    enumerable: true,
    get: function () {
        return PluginManager.HeatMaps;
    }
});
exports.JsonLib = PluginManager.JsonLib;
exports.Label = PluginManager.Label;
exports.LangUtils = PluginManager.LangUtils;
exports.MapLib = PluginManager.MapLib;
exports.MapParams = PluginManager.MapParams;
Object.defineProperty(exports, 'MapTypes', {
    enumerable: true,
    get: function () {
        return PluginManager.MapTypes;
    }
});
exports.Param = PluginManager.Param;
exports.PluginManager = PluginManager.PluginManager;
exports.Tile = PluginManager.Tile;
exports.Utils = PluginManager.Utils;
exports.Logger = logger.Logger;
exports.PluginDef = PluginDef;

//# sourceMappingURL=index.cjs.js.map