import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';

const discoveryInputChipsChipCss = "/*!\n *   Copyright 2022  SenX S.A.S.\n *\n *   Licensed under the Apache License, Version 2.0 (the \"License\");\n *   you may not use this file except in compliance with the License.\n *   You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n *   Unless required by applicable law or agreed to in writing, software\n *   distributed under the License is distributed on an \"AS IS\" BASIS,\n *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n *   See the License for the specific language governing permissions and\n *   limitations under the License.\n */:host{display:-ms-inline-flexbox;display:inline-flex;-ms-flex-pack:distribute;justify-content:space-around;-ms-flex-align:center;align-items:center;background-color:var(--chip-background-color, #f0f0f0);border-color:var(--chip-border-color, transparent);border-width:var(--chip-border-width, 0px);font-size:var(--chip-font-size, 24px);line-height:var(--chip-font-size, 24px);white-space:nowrap;border-radius:var(--warp-view-input-border-radius, 0.25rem);margin-left:3px;padding:5px;height:20px}:host #label{padding-left:5px}:host #close_icon{cursor:pointer}:host #icon{height:var(--chip-icon-height, 16px);width:var(--chip-icon-width, 16px);-o-object-fit:scale-down;object-fit:scale-down}:host #close_icon{height:var(--chip-close-icon-height, 16px);width:var(--chip-close-icon-width, 16px);-o-object-fit:scale-down;object-fit:scale-down;margin-left:5px;pointer-events:all;display:inline-table}:host #close_icon_stroke{fill:var(--chip-close-icon-fill, lightgrey)}:host #close_icon:hover #close_icon_stroke{fill:var(--chip-close-icon-hover-fill, lightblue)}";
const DiscoveryInputChipsChipStyle0 = discoveryInputChipsChipCss;

const DiscoveryInputChipsChip = /*@__PURE__*/ proxyCustomElement(class DiscoveryInputChipsChip extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.removeChip = createEvent(this, "removeChip", 6);
        this.disabled = false;
    }
    render() {
        return h(Host, { key: 'a405199bb60fc5961d90cd0131400207b9f05cf1' }, h("span", { key: '1bcce43d7e5ab407d6aaf91d442b0623eec7de4d', id: "label", innerHTML: this.label }), this.disabled ? '' : h("div", { id: "close_icon", onClick: () => this.handleClose() }, h("svg", { fill: "#000000", xmlns: "http://www.w3.org/2000/svg", "xmlns:xlink": "http://www.w3.org/1999/xlink", version: "1.1", x: "0px", y: "0px", viewBox: "0 0 100 100", "enable-background": "new 0 0 100 100", "xml:space": "preserve" }, h("path", { id: "close_icon_stroke", d: "M50.433,0.892c-27.119,0-49.102,21.983-49.102,49.102s21.983,49.103,49.102,49.103s49.101-21.984,49.101-49.103  S77.552,0.892,50.433,0.892z M69.879,70.439l-0.05,0.053c-2.644,2.792-7.052,2.913-9.845,0.269l-10.192-9.649l-9.647,10.19  c-2.645,2.793-6.998,2.853-9.845,0.268l-0.053-0.048c-2.847-2.586-2.915-7.052-0.27-9.845l9.648-10.19L28.707,41.149  c-2.793-2.645-2.913-7.052-0.269-9.845l0.05-0.053c2.645-2.793,7.052-2.914,9.845-0.27l10.919,10.337l10.337-10.918  c2.645-2.793,7.053-2.913,9.846-0.27l0.052,0.049c2.793,2.644,2.913,7.053,0.27,9.845L59.418,50.945l10.192,9.65  C72.402,63.239,72.523,67.647,69.879,70.439z" }))));
    }
    handleClose() {
        if (!this.disabled) {
            this.removeChip.emit(this.position);
        }
    }
    static get style() { return DiscoveryInputChipsChipStyle0; }
}, [1, "discovery-input-chips-chip", {
        "label": [1],
        "position": [1],
        "disabled": [4]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["discovery-input-chips-chip"];
    components.forEach(tagName => { switch (tagName) {
        case "discovery-input-chips-chip":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, DiscoveryInputChipsChip);
            }
            break;
    } });
}

export { DiscoveryInputChipsChip as D, defineCustomElement as d };

//# sourceMappingURL=discovery-input-chips-chip2.js.map