import { proxyCustomElement, HTMLElement, createEvent, h } from '@stencil/core/internal/client';
import { c as commonjsGlobal, P as Param, U as Utils, G as GTSLib, L as Logger, v as v4 } from './utils.js';
import { d as domtoimage } from './dom-to-image.js';
import { d as defineCustomElement$4 } from './discovery-input-chips2.js';
import { d as defineCustomElement$3 } from './discovery-input-chips-chip2.js';
import { d as defineCustomElement$2 } from './discovery-input-date-range2.js';
import { d as defineCustomElement$1 } from './discovery-slider2.js';

var autoComplete$1 = {exports: {}};

(function (module, exports) {
(function (global, factory) {
  module.exports = factory() ;
})(commonjsGlobal, (function () {
  function _arrayLikeToArray(r, a) {
    (null == a || a > r.length) && (a = r.length);
    for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e];
    return n;
  }
  function _arrayWithoutHoles(r) {
    if (Array.isArray(r)) return _arrayLikeToArray(r);
  }
  function _createForOfIteratorHelper(r, e) {
    var t = "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"];
    if (!t) {
      if (Array.isArray(r) || (t = _unsupportedIterableToArray(r)) || e) {
        t && (r = t);
        var n = 0,
          F = function () {};
        return {
          s: F,
          n: function () {
            return n >= r.length ? {
              done: !0
            } : {
              done: !1,
              value: r[n++]
            };
          },
          e: function (r) {
            throw r;
          },
          f: F
        };
      }
      throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
    }
    var o,
      a = !0,
      u = !1;
    return {
      s: function () {
        t = t.call(r);
      },
      n: function () {
        var r = t.next();
        return a = r.done, r;
      },
      e: function (r) {
        u = !0, o = r;
      },
      f: function () {
        try {
          a || null == t.return || t.return();
        } finally {
          if (u) throw o;
        }
      }
    };
  }
  function _defineProperty(e, r, t) {
    return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, {
      value: t,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }) : e[r] = t, e;
  }
  function _iterableToArray(r) {
    if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r);
  }
  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  function ownKeys(e, r) {
    var t = Object.keys(e);
    if (Object.getOwnPropertySymbols) {
      var o = Object.getOwnPropertySymbols(e);
      r && (o = o.filter(function (r) {
        return Object.getOwnPropertyDescriptor(e, r).enumerable;
      })), t.push.apply(t, o);
    }
    return t;
  }
  function _objectSpread2(e) {
    for (var r = 1; r < arguments.length; r++) {
      var t = null != arguments[r] ? arguments[r] : {};
      r % 2 ? ownKeys(Object(t), !0).forEach(function (r) {
        _defineProperty(e, r, t[r]);
      }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) {
        Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r));
      });
    }
    return e;
  }
  function _toConsumableArray(r) {
    return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread();
  }
  function _toPrimitive(t, r) {
    if ("object" != typeof t || !t) return t;
    var e = t[Symbol.toPrimitive];
    if (void 0 !== e) {
      var i = e.call(t, r || "default");
      if ("object" != typeof i) return i;
      throw new TypeError("@@toPrimitive must return a primitive value.");
    }
    return ("string" === r ? String : Number)(t);
  }
  function _toPropertyKey(t) {
    var i = _toPrimitive(t, "string");
    return "symbol" == typeof i ? i : i + "";
  }
  function _typeof(o) {
    "@babel/helpers - typeof";

    return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) {
      return typeof o;
    } : function (o) {
      return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o;
    }, _typeof(o);
  }
  function _unsupportedIterableToArray(r, a) {
    if (r) {
      if ("string" == typeof r) return _arrayLikeToArray(r, a);
      var t = {}.toString.call(r).slice(8, -1);
      return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0;
    }
  }

  var select$1 = function select(element) {
    return typeof element === "string" ? document.querySelector(element) : element();
  };
  var create = function create(tag, options) {
    var el = typeof tag === "string" ? document.createElement(tag) : tag;
    for (var key in options) {
      var val = options[key];
      if (key === "inside") {
        val.append(el);
      } else if (key === "dest") {
        select$1(val[0]).insertAdjacentElement(val[1], el);
      } else if (key === "around") {
        var ref = val;
        ref.parentNode.insertBefore(el, ref);
        el.append(ref);
        if (ref.getAttribute("autofocus") != null) ref.focus();
      } else if (key in el) {
        el[key] = val;
      } else {
        el.setAttribute(key, val);
      }
    }
    return el;
  };
  var getQuery = function getQuery(field) {
    return field instanceof HTMLInputElement || field instanceof HTMLTextAreaElement ? field.value : field.innerHTML;
  };
  var format = function format(value, diacritics) {
    value = String(value).toLowerCase();
    return diacritics ? value.normalize("NFD").replace(/[\u0300-\u036f]/g, "").normalize("NFC") : value;
  };
  var debounce = function debounce(callback, duration) {
    var timer;
    return function () {
      clearTimeout(timer);
      timer = setTimeout(function () {
        return callback();
      }, duration);
    };
  };
  var checkTrigger = function checkTrigger(query, condition, threshold) {
    return condition ? condition(query) : query.length >= threshold;
  };
  var mark = function mark(value, cls) {
    return create("mark", _objectSpread2({
      innerHTML: value
    }, typeof cls === "string" && {
      "class": cls
    })).outerHTML;
  };

  var configure = (function (ctx) {
    var name = ctx.name,
      options = ctx.options,
      resultsList = ctx.resultsList,
      resultItem = ctx.resultItem;
    for (var option in options) {
      if (_typeof(options[option]) === "object") {
        if (!ctx[option]) ctx[option] = {};
        for (var subOption in options[option]) {
          ctx[option][subOption] = options[option][subOption];
        }
      } else {
        ctx[option] = options[option];
      }
    }
    ctx.selector = ctx.selector || "#" + name;
    resultsList.destination = resultsList.destination || ctx.selector;
    resultsList.id = resultsList.id || name + "_list_" + ctx.id;
    resultItem.id = resultItem.id || name + "_result";
    ctx.input = select$1(ctx.selector);
  });

  var eventEmitter = (function (name, ctx) {
    ctx.input.dispatchEvent(new CustomEvent(name, {
      bubbles: true,
      detail: ctx.feedback,
      cancelable: true
    }));
  });

  var search = (function (query, record, options) {
    var _ref = options || {},
      mode = _ref.mode,
      diacritics = _ref.diacritics,
      highlight = _ref.highlight;
    var nRecord = format(record, diacritics);
    record = String(record);
    query = format(query, diacritics);
    if (mode === "loose") {
      query = query.replace(/ /g, "");
      var qLength = query.length;
      var cursor = 0;
      var match = Array.from(record).map(function (character, index) {
        if (cursor < qLength && nRecord[index] === query[cursor]) {
          character = highlight ? mark(character, highlight) : character;
          cursor++;
        }
        return character;
      }).join("");
      if (cursor === qLength) return match;
    } else {
      var _match = nRecord.indexOf(query);
      if (~_match) {
        query = record.substring(_match, _match + query.length);
        _match = highlight ? record.replace(query, mark(query, highlight)) : record;
        return _match;
      }
    }
  });

  var getData = function getData(ctx, query) {
    return new Promise(function ($return, $error) {
      var data;
      data = ctx.data;
      if (data.cache && data.store) return $return();
      return new Promise(function ($return, $error) {
        if (typeof data.src === "function") {
          return new Promise(function ($return, $error) {
            if (data.src.constructor.name === "AsyncFunction") {
              return data.src(query).then($return, $error);
            }
            return $return(data.src(query));
          }).then($return, $error);
        }
        return $return(data.src);
      }).then(function ($await_7) {
        try {
          ctx.feedback = data.store = $await_7;
          eventEmitter("response", ctx);
          return $return();
        } catch ($boundEx) {
          return $error($boundEx);
        }
      }, $error);
    });
  };
  var findMatches = function findMatches(query, ctx) {
    var data = ctx.data,
      searchEngine = ctx.searchEngine;
    var matches = [];
    data.store.forEach(function (value, index) {
      var find = function find(key) {
        var record = key ? value[key] : value;
        var match = typeof searchEngine === "function" ? searchEngine(query, record) : search(query, record, {
          mode: searchEngine,
          diacritics: ctx.diacritics,
          highlight: ctx.resultItem.highlight
        });
        if (!match) return;
        var result = {
          match: match,
          value: value
        };
        if (key) result.key = key;
        matches.push(result);
      };
      if (data.keys) {
        var _iterator = _createForOfIteratorHelper(data.keys),
          _step;
        try {
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            var key = _step.value;
            find(key);
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
      } else {
        find();
      }
    });
    if (data.filter) matches = data.filter(matches);
    var results = matches.slice(0, ctx.resultsList.maxResults);
    ctx.feedback = {
      query: query,
      matches: matches,
      results: results
    };
    eventEmitter("results", ctx);
  };

  var Expand = "aria-expanded";
  var Active = "aria-activedescendant";
  var Selected = "aria-selected";
  var feedback = function feedback(ctx, index) {
    ctx.feedback.selection = _objectSpread2({
      index: index
    }, ctx.feedback.results[index]);
  };
  var render = function render(ctx) {
    var resultsList = ctx.resultsList,
      list = ctx.list,
      resultItem = ctx.resultItem,
      feedback = ctx.feedback;
    var matches = feedback.matches,
      results = feedback.results;
    ctx.cursor = -1;
    list.innerHTML = "";
    if (matches.length || resultsList.noResults) {
      var fragment = new DocumentFragment();
      results.forEach(function (result, index) {
        var element = create(resultItem.tag, _objectSpread2({
          id: "".concat(resultItem.id, "_").concat(index),
          role: "option",
          innerHTML: result.match,
          inside: fragment
        }, resultItem["class"] && {
          "class": resultItem["class"]
        }));
        if (resultItem.element) resultItem.element(element, result);
      });
      list.append(fragment);
      if (resultsList.element) resultsList.element(list, feedback);
      open(ctx);
    } else {
      close(ctx);
    }
  };
  var open = function open(ctx) {
    if (ctx.isOpen) return;
    (ctx.wrapper || ctx.input).setAttribute(Expand, true);
    ctx.list.removeAttribute("hidden");
    ctx.isOpen = true;
    eventEmitter("open", ctx);
  };
  var close = function close(ctx) {
    if (!ctx.isOpen) return;
    (ctx.wrapper || ctx.input).setAttribute(Expand, false);
    ctx.input.setAttribute(Active, "");
    ctx.list.setAttribute("hidden", "");
    ctx.isOpen = false;
    eventEmitter("close", ctx);
  };
  var goTo = function goTo(index, ctx) {
    var resultItem = ctx.resultItem;
    var results = ctx.list.getElementsByTagName(resultItem.tag);
    var cls = resultItem.selected ? resultItem.selected.split(" ") : false;
    if (ctx.isOpen && results.length) {
      var _results$index$classL;
      var state = ctx.cursor;
      if (index >= results.length) index = 0;
      if (index < 0) index = results.length - 1;
      ctx.cursor = index;
      if (state > -1) {
        var _results$state$classL;
        results[state].removeAttribute(Selected);
        if (cls) (_results$state$classL = results[state].classList).remove.apply(_results$state$classL, _toConsumableArray(cls));
      }
      results[index].setAttribute(Selected, true);
      if (cls) (_results$index$classL = results[index].classList).add.apply(_results$index$classL, _toConsumableArray(cls));
      ctx.input.setAttribute(Active, results[ctx.cursor].id);
      ctx.list.scrollTop = results[index].offsetTop - ctx.list.clientHeight + results[index].clientHeight + 5;
      ctx.feedback.cursor = ctx.cursor;
      feedback(ctx, index);
      eventEmitter("navigate", ctx);
    }
  };
  var next = function next(ctx) {
    goTo(ctx.cursor + 1, ctx);
  };
  var previous = function previous(ctx) {
    goTo(ctx.cursor - 1, ctx);
  };
  var select = function select(ctx, event, index) {
    index = index >= 0 ? index : ctx.cursor;
    if (index < 0) return;
    ctx.feedback.event = event;
    feedback(ctx, index);
    eventEmitter("selection", ctx);
    close(ctx);
  };
  var click = function click(event, ctx) {
    var itemTag = ctx.resultItem.tag.toUpperCase();
    var items = Array.from(ctx.list.querySelectorAll(itemTag));
    var item = event.target.closest(itemTag);
    if (item && item.nodeName === itemTag) {
      select(ctx, event, items.indexOf(item));
    }
  };
  var navigate = function navigate(event, ctx) {
    switch (event.keyCode) {
      case 40:
      case 38:
        event.preventDefault();
        event.keyCode === 40 ? next(ctx) : previous(ctx);
        break;
      case 13:
        if (!ctx.submit) event.preventDefault();
        if (ctx.cursor >= 0) select(ctx, event);
        break;
      case 9:
        if (ctx.resultsList.tabSelect && ctx.cursor >= 0) select(ctx, event);
        break;
      case 27:
        ctx.input.value = "";
        eventEmitter('clear', ctx);
        close(ctx);
        break;
    }
  };

  function start (ctx, q) {
    var _this = this;
    return new Promise(function ($return, $error) {
      var queryVal, condition;
      queryVal = q || getQuery(ctx.input);
      queryVal = ctx.query ? ctx.query(queryVal) : queryVal;
      condition = checkTrigger(queryVal, ctx.trigger, ctx.threshold);
      if (condition) {
        return getData(ctx, queryVal).then(function ($await_2) {
          try {
            if (ctx.feedback instanceof Error) return $return();
            findMatches(queryVal, ctx);
            if (ctx.resultsList) render(ctx);
            return $If_1.call(_this);
          } catch ($boundEx) {
            return $error($boundEx);
          }
        }, $error);
      } else {
        close(ctx);
        return $If_1.call(_this);
      }
      function $If_1() {
        return $return();
      }
    });
  }

  var eventsManager = function eventsManager(events, callback) {
    for (var element in events) {
      for (var event in events[element]) {
        callback(element, event);
      }
    }
  };
  var addEvents = function addEvents(ctx) {
    var events = ctx.events;
    var run = debounce(function () {
      return start(ctx);
    }, ctx.debounce);
    var publicEvents = ctx.events = _objectSpread2({
      input: _objectSpread2({}, events && events.input)
    }, ctx.resultsList && {
      list: events ? _objectSpread2({}, events.list) : {}
    });
    var privateEvents = {
      input: {
        input: function input() {
          run();
        },
        keydown: function keydown(event) {
          navigate(event, ctx);
        },
        blur: function blur() {
          close(ctx);
        }
      },
      list: {
        mousedown: function mousedown(event) {
          event.preventDefault();
        },
        click: function click$1(event) {
          click(event, ctx);
        }
      }
    };
    eventsManager(privateEvents, function (element, event) {
      if (!ctx.resultsList && event !== "input") return;
      if (publicEvents[element][event]) return;
      publicEvents[element][event] = privateEvents[element][event];
    });
    eventsManager(publicEvents, function (element, event) {
      ctx[element].addEventListener(event, publicEvents[element][event]);
    });
  };
  var removeEvents = function removeEvents(ctx) {
    eventsManager(ctx.events, function (element, event) {
      ctx[element].removeEventListener(event, ctx.events[element][event]);
    });
  };

  function init (ctx) {
    var _this = this;
    return new Promise(function ($return, $error) {
      var placeHolder, resultsList, parentAttrs;
      placeHolder = ctx.placeHolder;
      resultsList = ctx.resultsList;
      parentAttrs = {
        role: "combobox",
        "aria-owns": resultsList.id,
        "aria-haspopup": true,
        "aria-expanded": false
      };
      create(ctx.input, _objectSpread2(_objectSpread2({
        "aria-controls": resultsList.id,
        "aria-autocomplete": "both"
      }, placeHolder && {
        placeholder: placeHolder
      }), !ctx.wrapper && _objectSpread2({}, parentAttrs)));
      if (ctx.wrapper) ctx.wrapper = create("div", _objectSpread2({
        around: ctx.input,
        "class": ctx.name + "_wrapper"
      }, parentAttrs));
      if (resultsList) ctx.list = create(resultsList.tag, _objectSpread2({
        dest: [resultsList.destination, resultsList.position],
        id: resultsList.id,
        role: "listbox",
        hidden: "hidden"
      }, resultsList["class"] && {
        "class": resultsList["class"]
      }));
      addEvents(ctx);
      if (ctx.data.cache) {
        return getData(ctx).then(function ($await_2) {
          try {
            return $If_1.call(_this);
          } catch ($boundEx) {
            return $error($boundEx);
          }
        }, $error);
      }
      function $If_1() {
        eventEmitter("init", ctx);
        return $return();
      }
      return $If_1.call(_this);
    });
  }

  function extend (autoComplete) {
    var prototype = autoComplete.prototype;
    prototype.init = function () {
      init(this);
    };
    prototype.start = function (query) {
      start(this, query);
    };
    prototype.unInit = function () {
      if (this.wrapper) {
        var parentNode = this.wrapper.parentNode;
        parentNode.insertBefore(this.input, this.wrapper);
        parentNode.removeChild(this.wrapper);
      }
      removeEvents(this);
    };
    prototype.open = function () {
      open(this);
    };
    prototype.close = function () {
      close(this);
    };
    prototype.goTo = function (index) {
      goTo(index, this);
    };
    prototype.next = function () {
      next(this);
    };
    prototype.previous = function () {
      previous(this);
    };
    prototype.select = function (index) {
      select(this, null, index);
    };
    prototype.search = function (query, record, options) {
      return search(query, record, options);
    };
  }

  function autoComplete(config) {
    this.options = config;
    this.id = autoComplete.instances = (autoComplete.instances || 0) + 1;
    this.name = "autoComplete";
    this.wrapper = 1;
    this.threshold = 1;
    this.debounce = 0;
    this.resultsList = {
      position: "afterend",
      tag: "ul",
      maxResults: 5
    };
    this.resultItem = {
      tag: "li"
    };
    configure(this);
    extend.call(this, autoComplete);
    init(this);
  }

  return autoComplete;

}));
}(autoComplete$1));

const autoComplete = autoComplete$1.exports;

var fuzzysort$1 = {exports: {}};

(function (module) {
((root, UMD) => {
  if(module.exports) module.exports = UMD();
  else root['fuzzysort'] = UMD();
})(commonjsGlobal, _ => {

  var single = (search, target) => {
    if(!search || !target) return NULL

    var preparedSearch = getPreparedSearch(search);
    if(!isPrepared(target)) target = getPrepared(target);

    var searchBitflags = preparedSearch.bitflags;
    if((searchBitflags & target._bitflags) !== searchBitflags) return NULL

    return algorithm(preparedSearch, target)
  };

  var go = (search, targets, options) => {
    if(!search) return options?.all ? all(targets, options) : noResults

    var preparedSearch = getPreparedSearch(search);
    var searchBitflags = preparedSearch.bitflags;
    var containsSpace  = preparedSearch.containsSpace;

    var threshold = denormalizeScore( options?.threshold || 0 );
    var limit     = options?.limit || INFINITY;

    var resultsLen = 0; var limitedCount = 0;
    var targetsLen = targets.length;

    function push_result(result) {
      if(resultsLen < limit) { q.add(result); ++resultsLen; }
      else {
        ++limitedCount;
        if(result._score > q.peek()._score) q.replaceTop(result);
      }
    }

    // This code is copy/pasted 3 times for performance reasons [options.key, options.keys, no keys]

    // options.key
    if(options?.key) {
      var key = options.key;
      for(var i = 0; i < targetsLen; ++i) { var obj = targets[i];
        var target = getValue(obj, key);
        if(!target) continue
        if(!isPrepared(target)) target = getPrepared(target);

        if((searchBitflags & target._bitflags) !== searchBitflags) continue
        var result = algorithm(preparedSearch, target);
        if(result === NULL) continue
        if(result._score < threshold) continue

        result.obj = obj;
        push_result(result);
      }

    // options.keys
    } else if(options?.keys) {
      var keys = options.keys;
      var keysLen = keys.length;

      outer: for(var i = 0; i < targetsLen; ++i) { var obj = targets[i];

        { // early out based on bitflags
          var keysBitflags = 0;
          for (var keyI = 0; keyI < keysLen; ++keyI) {
            var key = keys[keyI];
            var target = getValue(obj, key);
            if(!target) { tmpTargets[keyI] = noTarget; continue }
            if(!isPrepared(target)) target = getPrepared(target);
            tmpTargets[keyI] = target;

            keysBitflags |= target._bitflags;
          }

          if((searchBitflags & keysBitflags) !== searchBitflags) continue
        }

        if(containsSpace) for(let i=0; i<preparedSearch.spaceSearches.length; i++) keysSpacesBestScores[i] = NEGATIVE_INFINITY;

        for (var keyI = 0; keyI < keysLen; ++keyI) {
          target = tmpTargets[keyI];
          if(target === noTarget) { tmpResults[keyI] = noTarget; continue }

          tmpResults[keyI] = algorithm(preparedSearch, target, /*allowSpaces=*/false, /*allowPartialMatch=*/containsSpace);
          if(tmpResults[keyI] === NULL) { tmpResults[keyI] = noTarget; continue }

          // todo: this seems weird and wrong. like what if our first match wasn't good. this should just replace it instead of averaging with it
          // if our second match isn't good we ignore it instead of averaging with it
          if(containsSpace) for(let i=0; i<preparedSearch.spaceSearches.length; i++) {
            if(allowPartialMatchScores[i] > -1000) {
              if(keysSpacesBestScores[i] > NEGATIVE_INFINITY) {
                var tmp = (keysSpacesBestScores[i] + allowPartialMatchScores[i]) / 4;/*bonus score for having multiple matches*/
                if(tmp > keysSpacesBestScores[i]) keysSpacesBestScores[i] = tmp;
              }
            }
            if(allowPartialMatchScores[i] > keysSpacesBestScores[i]) keysSpacesBestScores[i] = allowPartialMatchScores[i];
          }
        }

        if(containsSpace) {
          for(let i=0; i<preparedSearch.spaceSearches.length; i++) { if(keysSpacesBestScores[i] === NEGATIVE_INFINITY) continue outer }
        } else {
          var hasAtLeast1Match = false;
          for(let i=0; i < keysLen; i++) { if(tmpResults[i]._score !== NEGATIVE_INFINITY) { hasAtLeast1Match = true; break } }
          if(!hasAtLeast1Match) continue
        }

        var objResults = new KeysResult(keysLen);
        for(let i=0; i < keysLen; i++) { objResults[i] = tmpResults[i]; }

        if(containsSpace) {
          var score = 0;
          for(let i=0; i<preparedSearch.spaceSearches.length; i++) score += keysSpacesBestScores[i];
        } else {
          // todo could rewrite this scoring to be more similar to when there's spaces
          // if we match multiple keys give us bonus points
          var score = NEGATIVE_INFINITY;
          for(let i=0; i<keysLen; i++) {
            var result = objResults[i];
            if(result._score > -1000) {
              if(score > NEGATIVE_INFINITY) {
                var tmp = (score + result._score) / 4;/*bonus score for having multiple matches*/
                if(tmp > score) score = tmp;
              }
            }
            if(result._score > score) score = result._score;
          }
        }

        objResults.obj = obj;
        objResults._score = score;
        if(options?.scoreFn) {
          score = options.scoreFn(objResults);
          if(!score) continue
          score = denormalizeScore(score);
          objResults._score = score;
        }

        if(score < threshold) continue
        push_result(objResults);
      }

    // no keys
    } else {
      for(var i = 0; i < targetsLen; ++i) { var target = targets[i];
        if(!target) continue
        if(!isPrepared(target)) target = getPrepared(target);

        if((searchBitflags & target._bitflags) !== searchBitflags) continue
        var result = algorithm(preparedSearch, target);
        if(result === NULL) continue
        if(result._score < threshold) continue

        push_result(result);
      }
    }

    if(resultsLen === 0) return noResults
    var results = new Array(resultsLen);
    for(var i = resultsLen - 1; i >= 0; --i) results[i] = q.poll();
    results.total = resultsLen + limitedCount;
    return results
  };


  // this is written as 1 function instead of 2 for minification. perf seems fine ...
  // except when minified. the perf is very slow
  var highlight = (result, open='<b>', close='</b>') => {
    var callback = typeof open === 'function' ? open : undefined;

    var target      = result.target;
    var targetLen   = target.length;
    var indexes     = result.indexes;
    var highlighted = '';
    var matchI      = 0;
    var indexesI    = 0;
    var opened      = false;
    var parts       = [];

    for(var i = 0; i < targetLen; ++i) { var char = target[i];
      if(indexes[indexesI] === i) {
        ++indexesI;
        if(!opened) { opened = true;
          if(callback) {
            parts.push(highlighted); highlighted = '';
          } else {
            highlighted += open;
          }
        }

        if(indexesI === indexes.length) {
          if(callback) {
            highlighted += char;
            parts.push(callback(highlighted, matchI++)); highlighted = '';
            parts.push(target.substr(i+1));
          } else {
            highlighted += char + close + target.substr(i+1);
          }
          break
        }
      } else {
        if(opened) { opened = false;
          if(callback) {
            parts.push(callback(highlighted, matchI++)); highlighted = '';
          } else {
            highlighted += close;
          }
        }
      }
      highlighted += char;
    }

    return callback ? parts : highlighted
  };


  var prepare = (target) => {
    if(typeof target === 'number') target = ''+target;
    else if(typeof target !== 'string') target = '';
    var info = prepareLowerInfo(target);
    return new_result(target, {_targetLower:info._lower, _targetLowerCodes:info.lowerCodes, _bitflags:info.bitflags})
  };

  var cleanup = () => { preparedCache.clear(); preparedSearchCache.clear(); };


  // Below this point is only internal code
  // Below this point is only internal code
  // Below this point is only internal code
  // Below this point is only internal code


  class Result {
    get ['indexes']() { return this._indexes.slice(0, this._indexes.len).sort((a,b)=>a-b) }
    set ['indexes'](indexes) { return this._indexes = indexes }
    ['highlight'](open, close) { return highlight(this, open, close) }
    get ['score']() { return normalizeScore(this._score) }
    set ['score'](score) { this._score = denormalizeScore(score); }
  }

  class KeysResult extends Array {
    get ['score']() { return normalizeScore(this._score) }
    set ['score'](score) { this._score = denormalizeScore(score); }
  }

  var new_result = (target, options) => {
    const result = new Result();
    result['target']             = target;
    result['obj']                = options.obj                   ?? NULL;
    result._score                = options._score                ?? NEGATIVE_INFINITY;
    result._indexes              = options._indexes              ?? [];
    result._targetLower          = options._targetLower          ?? '';
    result._targetLowerCodes     = options._targetLowerCodes     ?? NULL;
    result._nextBeginningIndexes = options._nextBeginningIndexes ?? NULL;
    result._bitflags             = options._bitflags             ?? 0;
    return result
  };


  var normalizeScore = score => {
    if(score === NEGATIVE_INFINITY) return 0
    if(score > 1) return score
    return Math.E ** ( ((-score + 1)**.04307 - 1) * -2)
  };
  var denormalizeScore = normalizedScore => {
    if(normalizedScore === 0) return NEGATIVE_INFINITY
    if(normalizedScore > 1) return normalizedScore
    return 1 - Math.pow((Math.log(normalizedScore) / -2 + 1), 1 / 0.04307)
  };


  var prepareSearch = (search) => {
    if(typeof search === 'number') search = ''+search;
    else if(typeof search !== 'string') search = '';
    search = search.trim();
    var info = prepareLowerInfo(search);

    var spaceSearches = [];
    if(info.containsSpace) {
      var searches = search.split(/\s+/);
      searches = [...new Set(searches)]; // distinct
      for(var i=0; i<searches.length; i++) {
        if(searches[i] === '') continue
        var _info = prepareLowerInfo(searches[i]);
        spaceSearches.push({lowerCodes:_info.lowerCodes, _lower:searches[i].toLowerCase(), containsSpace:false});
      }
    }

    return {lowerCodes: info.lowerCodes, _lower: info._lower, containsSpace: info.containsSpace, bitflags: info.bitflags, spaceSearches: spaceSearches}
  };



  var getPrepared = (target) => {
    if(target.length > 999) return prepare(target) // don't cache huge targets
    var targetPrepared = preparedCache.get(target);
    if(targetPrepared !== undefined) return targetPrepared
    targetPrepared = prepare(target);
    preparedCache.set(target, targetPrepared);
    return targetPrepared
  };
  var getPreparedSearch = (search) => {
    if(search.length > 999) return prepareSearch(search) // don't cache huge searches
    var searchPrepared = preparedSearchCache.get(search);
    if(searchPrepared !== undefined) return searchPrepared
    searchPrepared = prepareSearch(search);
    preparedSearchCache.set(search, searchPrepared);
    return searchPrepared
  };


  var all = (targets, options) => {
    var results = []; results.total = targets.length; // this total can be wrong if some targets are skipped

    var limit = options?.limit || INFINITY;

    if(options?.key) {
      for(var i=0;i<targets.length;i++) { var obj = targets[i];
        var target = getValue(obj, options.key);
        if(target == NULL) continue
        if(!isPrepared(target)) target = getPrepared(target);
        var result = new_result(target.target, {_score: target._score, obj: obj});
        results.push(result); if(results.length >= limit) return results
      }
    } else if(options?.keys) {
      for(var i=0;i<targets.length;i++) { var obj = targets[i];
        var objResults = new KeysResult(options.keys.length);
        for (var keyI = options.keys.length - 1; keyI >= 0; --keyI) {
          var target = getValue(obj, options.keys[keyI]);
          if(!target) { objResults[keyI] = noTarget; continue }
          if(!isPrepared(target)) target = getPrepared(target);
          target._score = NEGATIVE_INFINITY;
          target._indexes.len = 0;
          objResults[keyI] = target;
        }
        objResults.obj = obj;
        objResults._score = NEGATIVE_INFINITY;
        results.push(objResults); if(results.length >= limit) return results
      }
    } else {
      for(var i=0;i<targets.length;i++) { var target = targets[i];
        if(target == NULL) continue
        if(!isPrepared(target)) target = getPrepared(target);
        target._score = NEGATIVE_INFINITY;
        target._indexes.len = 0;
        results.push(target); if(results.length >= limit) return results
      }
    }

    return results
  };


  var algorithm = (preparedSearch, prepared, allowSpaces=false, allowPartialMatch=false) => {
    if(allowSpaces===false && preparedSearch.containsSpace) return algorithmSpaces(preparedSearch, prepared, allowPartialMatch)

    var searchLower      = preparedSearch._lower;
    var searchLowerCodes = preparedSearch.lowerCodes;
    var searchLowerCode  = searchLowerCodes[0];
    var targetLowerCodes = prepared._targetLowerCodes;
    var searchLen        = searchLowerCodes.length;
    var targetLen        = targetLowerCodes.length;
    var searchI          = 0; // where we at
    var targetI          = 0; // where you at
    var matchesSimpleLen = 0;

    // very basic fuzzy match; to remove non-matching targets ASAP!
    // walk through target. find sequential matches.
    // if all chars aren't found then exit
    for(;;) {
      var isMatch = searchLowerCode === targetLowerCodes[targetI];
      if(isMatch) {
        matchesSimple[matchesSimpleLen++] = targetI;
        ++searchI; if(searchI === searchLen) break
        searchLowerCode = searchLowerCodes[searchI];
      }
      ++targetI; if(targetI >= targetLen) return NULL // Failed to find searchI
    }

    var searchI = 0;
    var successStrict = false;
    var matchesStrictLen = 0;

    var nextBeginningIndexes = prepared._nextBeginningIndexes;
    if(nextBeginningIndexes === NULL) nextBeginningIndexes = prepared._nextBeginningIndexes = prepareNextBeginningIndexes(prepared.target);
    targetI = matchesSimple[0]===0 ? 0 : nextBeginningIndexes[matchesSimple[0]-1];

    // Our target string successfully matched all characters in sequence!
    // Let's try a more advanced and strict test to improve the score
    // only count it as a match if it's consecutive or a beginning character!
    var backtrackCount = 0;
    if(targetI !== targetLen) for(;;) {
      if(targetI >= targetLen) {
        // We failed to find a good spot for this search char, go back to the previous search char and force it forward
        if(searchI <= 0) break // We failed to push chars forward for a better match

        ++backtrackCount; if(backtrackCount > 200) break // exponential backtracking is taking too long, just give up and return a bad match

        --searchI;
        var lastMatch = matchesStrict[--matchesStrictLen];
        targetI = nextBeginningIndexes[lastMatch];

      } else {
        var isMatch = searchLowerCodes[searchI] === targetLowerCodes[targetI];
        if(isMatch) {
          matchesStrict[matchesStrictLen++] = targetI;
          ++searchI; if(searchI === searchLen) { successStrict = true; break }
          ++targetI;
        } else {
          targetI = nextBeginningIndexes[targetI];
        }
      }
    }

    // check if it's a substring match
    var substringIndex = searchLen <= 1 ? -1 : prepared._targetLower.indexOf(searchLower, matchesSimple[0]); // perf: this is slow
    var isSubstring = !!~substringIndex;
    var isSubstringBeginning = !isSubstring ? false : substringIndex===0 || prepared._nextBeginningIndexes[substringIndex-1] === substringIndex;

    // if it's a substring match but not at a beginning index, let's try to find a substring starting at a beginning index for a better score
    if(isSubstring && !isSubstringBeginning) {
      for(var i=0; i<nextBeginningIndexes.length; i=nextBeginningIndexes[i]) {
        if(i <= substringIndex) continue

        for(var s=0; s<searchLen; s++) if(searchLowerCodes[s] !== prepared._targetLowerCodes[i+s]) break
        if(s === searchLen) { substringIndex = i; isSubstringBeginning = true; break }
      }
    }

    // tally up the score & keep track of matches for highlighting later
    // if it's a simple match, we'll switch to a substring match if a substring exists
    // if it's a strict match, we'll switch to a substring match only if that's a better score

    var calculateScore = matches => {
      var score = 0;

      var extraMatchGroupCount = 0;
      for(var i = 1; i < searchLen; ++i) {
        if(matches[i] - matches[i-1] !== 1) {score -= matches[i]; ++extraMatchGroupCount;}
      }
      var unmatchedDistance = matches[searchLen-1] - matches[0] - (searchLen-1);

      score -= (12+unmatchedDistance) * extraMatchGroupCount; // penality for more groups

      if(matches[0] !== 0) score -= matches[0]*matches[0]*.2; // penality for not starting near the beginning

      if(!successStrict) {
        score *= 1000;
      } else {
        // successStrict on a target with too many beginning indexes loses points for being a bad target
        var uniqueBeginningIndexes = 1;
        for(var i = nextBeginningIndexes[0]; i < targetLen; i=nextBeginningIndexes[i]) ++uniqueBeginningIndexes;

        if(uniqueBeginningIndexes > 24) score *= (uniqueBeginningIndexes-24)*10; // quite arbitrary numbers here ...
      }

      score -= (targetLen - searchLen)/2; // penality for longer targets

      if(isSubstring)          score /= 1+searchLen*searchLen*1; // bonus for being a full substring
      if(isSubstringBeginning) score /= 1+searchLen*searchLen*1; // bonus for substring starting on a beginningIndex

      score -= (targetLen - searchLen)/2; // penality for longer targets

      return score
    };

    if(!successStrict) {
      if(isSubstring) for(var i=0; i<searchLen; ++i) matchesSimple[i] = substringIndex+i; // at this point it's safe to overwrite matchehsSimple with substr matches
      var matchesBest = matchesSimple;
      var score = calculateScore(matchesBest);
    } else {
      if(isSubstringBeginning) {
        for(var i=0; i<searchLen; ++i) matchesSimple[i] = substringIndex+i; // at this point it's safe to overwrite matchehsSimple with substr matches
        var matchesBest = matchesSimple;
        var score = calculateScore(matchesSimple);
      } else {
        var matchesBest = matchesStrict;
        var score = calculateScore(matchesStrict);
      }
    }

    prepared._score = score;

    for(var i = 0; i < searchLen; ++i) prepared._indexes[i] = matchesBest[i];
    prepared._indexes.len = searchLen;

    const result    = new Result();
    result.target   = prepared.target;
    result._score   = prepared._score;
    result._indexes = prepared._indexes;
    return result
  };
  var algorithmSpaces = (preparedSearch, target, allowPartialMatch) => {
    var seen_indexes = new Set();
    var score = 0;
    var result = NULL;

    var first_seen_index_last_search = 0;
    var searches = preparedSearch.spaceSearches;
    var searchesLen = searches.length;
    var changeslen = 0;

    // Return _nextBeginningIndexes back to its normal state
    var resetNextBeginningIndexes = () => {
      for(let i=changeslen-1; i>=0; i--) target._nextBeginningIndexes[nextBeginningIndexesChanges[i*2 + 0]] = nextBeginningIndexesChanges[i*2 + 1];
    };

    var hasAtLeast1Match = false;
    for(var i=0; i<searchesLen; ++i) {
      allowPartialMatchScores[i] = NEGATIVE_INFINITY;
      var search = searches[i];

      result = algorithm(search, target);
      if(allowPartialMatch) {
        if(result === NULL) continue
        hasAtLeast1Match = true;
      } else {
        if(result === NULL) {resetNextBeginningIndexes(); return NULL}
      }

      // if not the last search, we need to mutate _nextBeginningIndexes for the next search
      var isTheLastSearch = i === searchesLen - 1;
      if(!isTheLastSearch) {
        var indexes = result._indexes;

        var indexesIsConsecutiveSubstring = true;
        for(let i=0; i<indexes.len-1; i++) {
          if(indexes[i+1] - indexes[i] !== 1) {
            indexesIsConsecutiveSubstring = false; break;
          }
        }

        if(indexesIsConsecutiveSubstring) {
          var newBeginningIndex = indexes[indexes.len-1] + 1;
          var toReplace = target._nextBeginningIndexes[newBeginningIndex-1];
          for(let i=newBeginningIndex-1; i>=0; i--) {
            if(toReplace !== target._nextBeginningIndexes[i]) break
            target._nextBeginningIndexes[i] = newBeginningIndex;
            nextBeginningIndexesChanges[changeslen*2 + 0] = i;
            nextBeginningIndexesChanges[changeslen*2 + 1] = toReplace;
            changeslen++;
          }
        }
      }

      score += result._score / searchesLen;
      allowPartialMatchScores[i] = result._score / searchesLen;

      // dock points based on order otherwise "c man" returns Manifest.cpp instead of CheatManager.h
      if(result._indexes[0] < first_seen_index_last_search) {
        score -= (first_seen_index_last_search - result._indexes[0]) * 2;
      }
      first_seen_index_last_search = result._indexes[0];

      for(var j=0; j<result._indexes.len; ++j) seen_indexes.add(result._indexes[j]);
    }

    if(allowPartialMatch && !hasAtLeast1Match) return NULL

    resetNextBeginningIndexes();

    // allows a search with spaces that's an exact substring to score well
    var allowSpacesResult = algorithm(preparedSearch, target, /*allowSpaces=*/true);
    if(allowSpacesResult !== NULL && allowSpacesResult._score > score) {
      if(allowPartialMatch) {
        for(var i=0; i<searchesLen; ++i) {
          allowPartialMatchScores[i] = allowSpacesResult._score / searchesLen;
        }
      }
      return allowSpacesResult
    }

    if(allowPartialMatch) result = target;
    result._score = score;

    var i = 0;
    for (let index of seen_indexes) result._indexes[i++] = index;
    result._indexes.len = i;

    return result
  };

  // we use this instead of just .normalize('NFD').replace(/[\u0300-\u036f]/g, '') because that screws with japanese characters
  var remove_accents = (str) => str.replace(/\p{Script=Latin}+/gu, match => match.normalize('NFD')).replace(/[\u0300-\u036f]/g, '');

  var prepareLowerInfo = (str) => {
    str = remove_accents(str);
    var strLen = str.length;
    var lower = str.toLowerCase();
    var lowerCodes = []; // new Array(strLen)    sparse array is too slow
    var bitflags = 0;
    var containsSpace = false; // space isn't stored in bitflags because of how searching with a space works

    for(var i = 0; i < strLen; ++i) {
      var lowerCode = lowerCodes[i] = lower.charCodeAt(i);

      if(lowerCode === 32) {
        containsSpace = true;
        continue // it's important that we don't set any bitflags for space
      }

      var bit = lowerCode>=97&&lowerCode<=122 ? lowerCode-97 // alphabet
              : lowerCode>=48&&lowerCode<=57  ? 26           // numbers
                                                             // 3 bits available
              : lowerCode<=127                ? 30           // other ascii
              :                                 31;           // other utf8
      bitflags |= 1<<bit;
    }

    return {lowerCodes:lowerCodes, bitflags:bitflags, containsSpace:containsSpace, _lower:lower}
  };
  var prepareBeginningIndexes = (target) => {
    var targetLen = target.length;
    var beginningIndexes = []; var beginningIndexesLen = 0;
    var wasUpper = false;
    var wasAlphanum = false;
    for(var i = 0; i < targetLen; ++i) {
      var targetCode = target.charCodeAt(i);
      var isUpper = targetCode>=65&&targetCode<=90;
      var isAlphanum = isUpper || targetCode>=97&&targetCode<=122 || targetCode>=48&&targetCode<=57;
      var isBeginning = isUpper && !wasUpper || !wasAlphanum || !isAlphanum;
      wasUpper = isUpper;
      wasAlphanum = isAlphanum;
      if(isBeginning) beginningIndexes[beginningIndexesLen++] = i;
    }
    return beginningIndexes
  };
  var prepareNextBeginningIndexes = (target) => {
    target = remove_accents(target);
    var targetLen = target.length;
    var beginningIndexes = prepareBeginningIndexes(target);
    var nextBeginningIndexes = []; // new Array(targetLen)     sparse array is too slow
    var lastIsBeginning = beginningIndexes[0];
    var lastIsBeginningI = 0;
    for(var i = 0; i < targetLen; ++i) {
      if(lastIsBeginning > i) {
        nextBeginningIndexes[i] = lastIsBeginning;
      } else {
        lastIsBeginning = beginningIndexes[++lastIsBeginningI];
        nextBeginningIndexes[i] = lastIsBeginning===undefined ? targetLen : lastIsBeginning;
      }
    }
    return nextBeginningIndexes
  };

  var preparedCache       = new Map();
  var preparedSearchCache = new Map();

  // the theory behind these being globals is to reduce garbage collection by not making new arrays
  var matchesSimple = []; var matchesStrict = [];
  var nextBeginningIndexesChanges = []; // allows straw berry to match strawberry well, by modifying the end of a substring to be considered a beginning index for the rest of the search
  var keysSpacesBestScores = []; var allowPartialMatchScores = [];
  var tmpTargets = []; var tmpResults = [];

  // prop = 'key'                  2.5ms optimized for this case, seems to be about as fast as direct obj[prop]
  // prop = 'key1.key2'            10ms
  // prop = ['key1', 'key2']       27ms
  // prop = obj => obj.tags.join() ??ms
  var getValue = (obj, prop) => {
    var tmp = obj[prop]; if(tmp !== undefined) return tmp
    if(typeof prop === 'function') return prop(obj) // this should run first. but that makes string props slower
    var segs = prop;
    if(!Array.isArray(prop)) segs = prop.split('.');
    var len = segs.length;
    var i = -1;
    while (obj && (++i < len)) obj = obj[segs[i]];
    return obj
  };

  var isPrepared = (x) => { return typeof x === 'object' && typeof x._bitflags === 'number' };
  var INFINITY = Infinity; var NEGATIVE_INFINITY = -INFINITY;
  var noResults = []; noResults.total = 0;
  var NULL = null;

  var noTarget = prepare('');

  // Hacked version of https://github.com/lemire/FastPriorityQueue.js
  var fastpriorityqueue=r=>{var e=[],o=0,a={},v=r=>{for(var a=0,v=e[a],c=1;c<o;){var s=c+1;a=c,s<o&&e[s]._score<e[c]._score&&(a=s),e[a-1>>1]=e[a],c=1+(a<<1);}for(var f=a-1>>1;a>0&&v._score<e[f]._score;f=(a=f)-1>>1)e[a]=e[f];e[a]=v;};return a.add=(r=>{var a=o;e[o++]=r;for(var v=a-1>>1;a>0&&r._score<e[v]._score;v=(a=v)-1>>1)e[a]=e[v];e[a]=r;}),a.poll=(r=>{if(0!==o){var a=e[0];return e[0]=e[--o],v(),a}}),a.peek=(r=>{if(0!==o)return e[0]}),a.replaceTop=(r=>{e[0]=r,v();}),a};
  var q = fastpriorityqueue(); // reuse this

  // fuzzysort is written this way for minification. all names are mangeled unless quoted
  return {'single':single, 'go':go, 'prepare':prepare, 'cleanup':cleanup}
}); // UMD
}(fuzzysort$1));

const fuzzysort = fuzzysort$1.exports;

const discoveryInputCss = "/*!\n *   Copyright 2022-2025 SenX S.A.S.\n *\n *   Licensed under the Apache License, Version 2.0 (the \"License\");\n *   you may not use this file except in compliance with the License.\n *   You may obtain a copy of the License at\n *\n *     http://www.apache.org/licenses/LICENSE-2.0\n *\n *   Unless required by applicable law or agreed to in writing, software\n *   distributed under the License is distributed on an \"AS IS\" BASIS,\n *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n *   See the License for the specific language governing permissions and\n *   limitations under the License.\n *//*!\n*   Copyright 2022-2024 SenX S.A.S.\n*\n*   Licensed under the Apache License, Version 2.0 (the \"License\");\n*   you may not use this file except in compliance with the License.\n*   You may obtain a copy of the License at\n*\n*     http://www.apache.org/licenses/LICENSE-2.0\n*\n*   Unless required by applicable law or agreed to in writing, software\n*   distributed under the License is distributed on an \"AS IS\" BASIS,\n*   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n*   See the License for the specific language governing permissions and\n*   limitations under the License.\n*/.autoComplete_wrapper{display:inline-block;position:relative}.autoComplete_wrapper>input{width:370px;height:40px;padding-left:10px;font-size:1rem;color:rgb(116, 116, 116);border-radius:4px;border:1px solid rgba(33, 33, 33, 0.2);outline:none}.autoComplete_wrapper>input::-webkit-input-placeholder{color:rgba(123, 123, 123, 0.5);-webkit-transition:all 0.3s ease;transition:all 0.3s ease}.autoComplete_wrapper>input::-moz-placeholder{color:rgba(123, 123, 123, 0.5);-moz-transition:all 0.3s ease;transition:all 0.3s ease}.autoComplete_wrapper>input:-ms-input-placeholder{color:rgba(123, 123, 123, 0.5);-ms-transition:all 0.3s ease;transition:all 0.3s ease}.autoComplete_wrapper>input::-ms-input-placeholder{color:rgba(123, 123, 123, 0.5);-ms-transition:all 0.3s ease;transition:all 0.3s ease}.autoComplete_wrapper>input::placeholder{color:rgba(123, 123, 123, 0.5);-webkit-transition:all 0.3s ease;transition:all 0.3s ease}.autoComplete_wrapper>ul{position:absolute;max-height:226px;overflow-y:scroll;top:100%;left:0;right:0;padding:0;margin:0.5rem 0 0 0;border-radius:4px;background-color:#fff;border:1px solid rgba(33, 33, 33, 0.1);z-index:1000;outline:none}.autoComplete_wrapper>ul>li{padding:10px 20px;list-style:none;text-align:left;font-size:16px;color:#212121;-webkit-transition:all 0.1s ease-in-out;transition:all 0.1s ease-in-out;border-radius:3px;background-color:rgba(255, 255, 255, 1);white-space:nowrap;overflow:hidden;text-overflow:ellipsis;-webkit-transition:all 0.2s ease;transition:all 0.2s ease}.autoComplete_wrapper>ul>li::-moz-selection{color:rgba(#ffffff, 0);background-color:rgba(#ffffff, 0)}.autoComplete_wrapper>ul>li::selection{color:rgba(#ffffff, 0);background-color:rgba(#ffffff, 0)}.autoComplete_wrapper>ul>li:hover{cursor:pointer;background-color:rgba(123, 123, 123, 0.1)}.autoComplete_wrapper>ul>li mark{background-color:transparent;color:rgba(255, 122, 122, 1);font-weight:bold}.autoComplete_wrapper>ul>li mark::-moz-selection{color:rgba(#ffffff, 0);background-color:rgba(#ffffff, 0)}.autoComplete_wrapper>ul>li mark::selection{color:rgba(#ffffff, 0);background-color:rgba(#ffffff, 0)}.autoComplete_wrapper>ul>li[aria-selected=\"true\"]{background-color:rgba(123, 123, 123, 0.1)}@media only screen and (max-width: 600px){.autoComplete_wrapper>input{width:18rem}}:host{display:block;position:relative;height:100%;width:100%}:host>div{height:100%;width:100%}:host .hidden{display:none}:host .chips-input-wrapper,:host input[type=text].discovery-input,:host input[type=password].discovery-input,:host input[type=date].discovery-input,:host input[type=time].discovery-input,:host input[type=number].discovery-input,:host textarea.discovery-input,:host input[type=file].discovery-input,:host select.discovery-input{margin:0.25rem 0.125rem;display:inline-block;position:relative;font-size:var(--warp-view-input-font-size, 1rem);border-radius:var(--warp-view-input-border-radius, 0.25rem);border:1px solid var(--warp-view-input-border-color, #c0c0c0);color:var(--warp-view-input-label-color, #404040);background-color:var(--warp-view-input-bg-color, #ffffff);vertical-align:middle;width:100%;height:34px;padding:1px 5px}:host .chips-input-wrapper[disabled],:host input[type=text].discovery-input[disabled],:host input[type=password].discovery-input[disabled],:host input[type=date].discovery-input[disabled],:host input[type=time].discovery-input[disabled],:host input[type=number].discovery-input[disabled],:host textarea.discovery-input[disabled],:host input[type=file].discovery-input[disabled],:host select.discovery-input[disabled]{background-color:var(--warp-view-input-disabled-bg-color, #c0c0c0);color:var(--warp-view-input-disabled-label-color, #404040);border:1px solid var(--warp-view-input-disabled-border-color, #c0c0c0)}:host .chips-input-wrapper:focus,:host input[type=text].discovery-input:focus,:host input[type=password].discovery-input:focus,:host input[type=date].discovery-input:focus,:host input[type=time].discovery-input:focus,:host input[type=number].discovery-input:focus,:host textarea.discovery-input:focus,:host input[type=file].discovery-input:focus,:host select.discovery-input:focus{outline:0;-webkit-box-shadow:0 0 0 0.25rem var(--warp-view-input-focus-outline-color, rgba(13, 110, 253, 0.25));box-shadow:0 0 0 0.25rem var(--warp-view-input-focus-outline-color, rgba(13, 110, 253, 0.25))}:host input[type=file].discovery-input{height:38px;padding:0}:host input.validation:invalid{outline:1px solid #dc3545 !important;padding-right:calc(1.5em + 0.75rem);background-image:url(\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 12 12' width='12' height='12' fill='none' stroke='%23dc3545'%3e%3ccircle cx='6' cy='6' r='4.5'/%3e%3cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3e%3ccircle cx='6' cy='8.2' r='.6' fill='%23dc3545' stroke='none'/%3e%3c/svg%3e\");background-repeat:no-repeat;background-position:right calc(0.375em + 0.1875rem) center;background-size:calc(0.75em + 0.375rem) calc(0.75em + 0.375rem)}:host input.validation:invalid:focus{border-color:#dc3545;-webkit-box-shadow:0 0 0 0.25rem rgba(220, 53, 69, 0.25);box-shadow:0 0 0 0.25rem rgba(220, 53, 69, 0.25)}:host input.validation:valid{outline:1px solid #198754 !important;padding-right:calc(1.5em + 0.75rem);background-image:url(\"data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 8 8'%3e%3cpath fill='%23198754' d='M2.3 6.73.6 4.53c-.4-1.04.46-1.4 1.1-.8l1.1 1.4 3.4-3.8c.6-.63 1.6-.27 1.2.7l-4 4.6c-.43.5-.8.4-1.1.1z'/%3e%3c/svg%3e\");background-repeat:no-repeat;background-position:right calc(0.375em + 0.1875rem) center;background-size:calc(0.75em + 0.375rem) calc(0.75em + 0.375rem)}:host input.validation:valid:focus{border-color:#198754;-webkit-box-shadow:0 0 0 0.25rem rgba(25, 135, 84, 0.25);box-shadow:0 0 0 0.25rem rgba(25, 135, 84, 0.25)}:host textarea.discovery-input{width:calc(100% - 0.75rem);height:100%}:host .chips-input-wrapper{min-height:34px;height:-webkit-fit-content;height:-moz-fit-content;height:fit-content}:host .chips-input-wrapper.disabled{background-color:var(--warp-view-input-disabled-bg-color, #c0c0c0);color:var(--warp-view-input-disabled-label-color, #404040);border:1px solid var(--warp-view-input-disabled-border-color, #c0c0c0)}:host select.discovery-input{height:38px}:host select.discovery-input[multiple]{height:100%}:host select.discovery-input option{line-height:2.5em}:host .flatpickr-wrapper{width:100%;margin-right:20px;-ms-flex-align:center;align-items:center;-ms-flex-pack:center;justify-content:center;margin-bottom:10px}:host .flatpickr-wrapper .numInputWrapper span.arrowUp,:host .flatpickr-wrapper .numInputWrapper span.arrowDown{height:50%}:host .discovery-input-wrapper{display:-ms-flexbox;display:flex;-ms-flex-direction:row;flex-direction:row;-ms-flex-align:stretch;align-items:stretch;height:100%}:host .discovery-input-wrapper.type-date,:host .discovery-input-wrapper.type-date-range,:host .discovery-input-wrapper.type-autocomplete{height:auto}:host .discovery-input-wrapper.type-textarea{-ms-flex-direction:column;flex-direction:column}:host .autoComplete_wrapper{width:100%;margin-right:20px;margin-bottom:10px}:host .slider-wrapper{height:100%;width:calc(100% - 50px);padding-left:10px;padding-right:10px}:host .multi-cb-wrapper{display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column;height:100%;position:absolute;width:100%}:host .multi-cb-wrapper .multi-cb-layout{-ms-flex:1 1 auto;flex:1 1 auto;min-height:0;padding-right:17px;position:relative;display:-ms-flexbox;display:flex;-ms-flex-direction:column;flex-direction:column}:host .multi-cb-wrapper .multi-cb-list-wrapper{overflow-y:auto;height:100%;margin-right:-15px}:host .multi-cb-wrapper .multi-cb-buttons-wrapper{padding-top:5px}:host .multi-cb-wrapper .multi-cb-buttons-wrapper{display:-ms-flexbox;display:flex;-ms-flex-direction:row;flex-direction:row;-ms-flex-pack:justify;justify-content:space-between}:host input[type=file]::-webkit-file-upload-button{margin:0.25rem 0.125rem;display:inline-block;font-weight:400;line-height:1.5em;text-align:center;text-decoration:none;vertical-align:middle;cursor:pointer;font-size:var(--warp-view-button-font-size, 1rem);border:1px solid var(--warp-view-button-border-color, #004eff);padding:var(--warp-view-button-padding, 0.375rem 0.75rem);color:var(--warp-view-button-label-color, #ffffff);background-color:var(--warp-view-button-bg-color, #004eff);min-width:var(--warp-view-button-width, auto);border-radius:var(--warp-view-button-border-radius, 0.25rem)}:host button.discovery-btn,:host input[type=file]::file-selector-button{margin:0.25rem 0.125rem;display:inline-block;font-weight:400;line-height:1.5em;text-align:center;text-decoration:none;vertical-align:middle;cursor:pointer;font-size:var(--warp-view-button-font-size, 1rem);border:1px solid var(--warp-view-button-border-color, #004eff);padding:var(--warp-view-button-padding, 0.375rem 0.75rem);color:var(--warp-view-button-label-color, #ffffff);background-color:var(--warp-view-button-bg-color, #004eff);min-width:var(--warp-view-button-width, auto);border-radius:var(--warp-view-button-border-radius, 0.25rem)}:host input[type=file]::-webkit-file-upload-button.secondary{border:1px solid var(--warp-view-button-secondary-border-color, #a0a0a0);background-color:var(--warp-view-button-secondary-bg-color, #a0a0a0);color:var(--warp-view-button-secondary-label-color, #ffffff)}:host button.discovery-btn.secondary,:host input[type=file]::file-selector-button.secondary{border:1px solid var(--warp-view-button-secondary-border-color, #a0a0a0);background-color:var(--warp-view-button-secondary-bg-color, #a0a0a0);color:var(--warp-view-button-secondary-label-color, #ffffff)}:host input[type=file][disabled]::-webkit-file-upload-button{background-color:var(--warp-view-button-disabled-bg-color, #c0c0c0);color:var(--warp-view-button-disabled-label-color, #404040);border:1px solid var(--warp-view-button-disabled-border-color, #c0c0c0)}:host button:disabled,:host input[type=file][disabled]::file-selector-button{background-color:var(--warp-view-button-disabled-bg-color, #c0c0c0);color:var(--warp-view-button-disabled-label-color, #404040);border:1px solid var(--warp-view-button-disabled-border-color, #c0c0c0)}:host input[type=file]::-webkit-file-upload-button{margin:0 10px 0 0}:host input[type=file]::file-selector-button{margin:0 10px 0 0}:host .discovery-input-btn-wrapper.slider{margin-top:24px}:host .discovery-input-btn-wrapper.textarea{text-align:end}:host .range{display:-ms-flexbox;display:flex;-ms-flex-pack:start;justify-content:start;-ms-flex-align:center;align-items:center;-ms-flex-direction:row;flex-direction:row;margin:0.25rem 0.125rem;font-size:var(--warp-view-input-font-size, 1rem);border-radius:var(--warp-view-input-border-radius, 0.25rem);border:1px solid var(--warp-view-input-border-color, #c0c0c0);color:var(--warp-view-input-label-color, #404040);background-color:var(--warp-view-input-bg-color, #ffffff);height:34px;width:100%;padding:1px 5px}:host .range .flatpickr-wrapper{margin:0}:host .range span{padding-left:0.25rem;padding-right:0.25rem;font-size:var(--warp-view-input-font-size, 1rem);height:auto}:host .range .discovery-input,:host .range .discovery-input:focus{border:none !important;margin:0 !important;padding:0 !important;max-height:25px;cursor:pointer}:host .range.disabled{background-color:var(--warp-view-input-disabled-bg-color, #c0c0c0);color:var(--warp-view-input-disabled-label-color, #404040);border:1px solid var(--warp-view-input-disabled-border-color, #c0c0c0)}:host textarea{resize:none}";
const DiscoveryInputStyle0 = discoveryInputCss;

const DiscoveryInputComponent = /*@__PURE__*/ proxyCustomElement(class DiscoveryInputComponent extends HTMLElement {
    constructor() {
        super();
        this.__registerHost();
        this.__attachShadow();
        this.draw = createEvent(this, "draw", 7);
        this.execResult = createEvent(this, "execResult", 7);
        this.statusError = createEvent(this, "statusError", 7);
        this.discoveryEvent = createEvent(this, "discoveryEvent", 7);
        this.options = new Param();
        this.debug = false;
        this.parsing = false;
        this.rendering = false;
        this.value = '';
        this.subType = 'text';
        this.label = 'Ok';
        this.values = [];
        this.defOptions = Object.assign(Object.assign({}, new Param()), { input: { caseSensitive: true, onlyFromAutocomplete: true } });
        this.innerOptions = new Param();
        this.disabled = false;
        this.initialValues = [];
    }
    discoveryEventHandler(event) {
        const res = Utils.parseEventData(event.detail, this.innerOptions.eventHandler, this.el.id);
        if (res.style) {
            this.innerStyle = Utils.clone(Object.assign(Object.assign({}, this.innerStyle), res.style));
        }
    }
    updateRes() {
        var _a, _b;
        this.LOG.debug(['updateRes'], this.innerResult);
        this.innerResult = GTSLib.getData(this.result);
        this.innerOptions = Utils.mergeDeep((_a = this.innerOptions) !== null && _a !== void 0 ? _a : {}, this.innerResult.globalParams);
        if (this.innerOptions.customStyles) {
            this.innerStyle = Utils.clone(Object.assign(Object.assign({}, this.innerStyle), (_b = this.innerOptions.customStyles) !== null && _b !== void 0 ? _b : {}));
        }
        this.parseResult();
    }
    optionsUpdate(newValue, oldValue) {
        var _a, _b;
        (_a = this.LOG) === null || _a === void 0 ? void 0 : _a.debug(['optionsUpdate'], newValue, oldValue);
        let opts = newValue;
        if (!!newValue && typeof newValue === 'string') {
            opts = JSON.parse(newValue);
        }
        if (!Utils.deepEqual(opts, this.innerOptions)) {
            this.innerOptions = Utils.clone(opts);
            (_b = this.LOG) === null || _b === void 0 ? void 0 : _b.debug(['optionsUpdate 2'], { options: this.innerOptions, newValue, oldValue });
            this.parseResult();
        }
    }
    async resize() {
        // empty
    }
    // noinspection JSUnusedLocalSymbols
    async export(type = 'png') {
        const dims = Utils.getContentBounds(this.type === 'input:multi-cb' || this.type === 'input:slider'
            ? this.pngWrapper : this.root);
        this.width = dims.w - 15;
        this.height = dims.h;
        let bgColor = Utils.getCSSColor(this.el, '--warp-view-bg-color', 'transparent');
        bgColor = ((this.innerOptions) || { bgColor }).bgColor || bgColor;
        const dm = ((this.result || {
            globalParams: { bgColor },
        }).globalParams || { bgColor });
        bgColor = dm.bgColor || bgColor;
        if (this.type === 'input:slider') {
            return await this.inputField.export(type, bgColor);
        }
        else {
            return await domtoimage.toPng(this.type === 'input:multi-cb' ? this.pngWrapper : this.root, {
                height: this.height,
                width: this.width,
                bgcolor: bgColor,
            });
        }
    }
    // noinspection JSUnusedGlobalSymbols
    componentWillLoad() {
        var _a, _b, _c;
        this.LOG = new Logger(DiscoveryInputComponent, this.debug);
        this.parsing = true;
        if (typeof this.options === 'string') {
            this.options = JSON.parse(this.options);
        }
        this.innerResult = GTSLib.getData(this.result);
        this.subType = this.type.split(':')[1];
        let options = Utils.mergeDeep(this.defOptions, (_a = this.options) !== null && _a !== void 0 ? _a : {});
        options = Utils.mergeDeep(options || {}, this.innerResult.globalParams);
        this.innerOptions = Utils.clone(options);
        if (this.innerOptions.customStyles) {
            this.innerStyle = Utils.clone(Object.assign(Object.assign({}, this.innerStyle), (_b = this.innerOptions.customStyles) !== null && _b !== void 0 ? _b : {}));
        }
        (_c = this.LOG) === null || _c === void 0 ? void 0 : _c.debug(['componentWillLoad'], {
            type: this.type,
            innerOptions: this.innerOptions,
            innerResult: this.innerResult,
            result: this.result,
        });
    }
    // noinspection JSUnusedGlobalSymbols
    componentDidLoad() {
        var _a;
        switch (this.subType) {
            case 'date':
                if (!GTSLib.isArray(this.value)) {
                    this.value = [this.value];
                }
                break;
            case 'date-range':
                break;
            case 'autocomplete':
                // noinspection JSPotentiallyInvalidConstructorUsage
                this.autoCompleteJS = new autoComplete({
                    placeHolder: 'Search...',
                    selector: () => this.inputField,
                    data: { src: this.values, keys: 'v' },
                    resultItem: { highlight: { render: true } },
                    events: {
                        input: {
                            selection: (event) => {
                                var _a, _b, _c;
                                const selection = event.detail.selection.value.v;
                                this.autoCompleteJS.input.value = selection;
                                this.selectedValue = selection;
                                (_a = this.LOG) === null || _a === void 0 ? void 0 : _a.debug(['selection'], { v: this.selectedValue, b: !((_b = this.innerOptions.input) === null || _b === void 0 ? void 0 : _b.showButton) });
                                if (!((_c = this.innerOptions.input) === null || _c === void 0 ? void 0 : _c.showButton)) {
                                    this.handleClick();
                                }
                            },
                        },
                    },
                });
                break;
        }
        this.parseResult();
        (_a = this.LOG) === null || _a === void 0 ? void 0 : _a.debug(['componentDidLoad'], {
            type: this.type,
            innerOptions: this.innerOptions,
            innerResult: this.innerResult,
            result: this.result,
        });
        this.draw.emit();
    }
    handleClick() {
        var _a, _b, _c;
        if (((_a = this.innerOptions.input) === null || _a === void 0 ? void 0 : _a.delayRequest) && ((_b = this.innerOptions.input) === null || _b === void 0 ? void 0 : _b.delayRequest) > 0) {
            if (this.delayTimer) {
                window.clearInterval(this.delayTimer);
            }
            this.delayTimer = setTimeout(() => this.handleClickRT(), (_c = this.innerOptions.input) === null || _c === void 0 ? void 0 : _c.delayRequest);
        }
        else {
            this.handleClickRT();
        }
    }
    ;
    handleClickRT() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
        const valid = !((_b = (_a = this.innerOptions) === null || _a === void 0 ? void 0 : _a.input) === null || _b === void 0 ? void 0 : _b.validation)
            || (!!((_d = (_c = this.innerOptions) === null || _c === void 0 ? void 0 : _c.input) === null || _d === void 0 ? void 0 : _d.validation)
                && !!((_f = (_e = this.inputField) === null || _e === void 0 ? void 0 : _e.validity) === null || _f === void 0 ? void 0 : _f.valid)
                && (!this.inputField2 || !!((_h = (_g = this.inputField2) === null || _g === void 0 ? void 0 : _g.validity) === null || _h === void 0 ? void 0 : _h.valid)));
        if (this.inputField && !['file', 'date', 'date-range', 'multi', 'chips', 'chips-autocomplete'].includes(this.subType)) {
            if ('value' in this.inputField) {
                this.selectedValue = this.inputField.value;
            }
        }
        for (const e of ((_k = (_j = this.innerResult) === null || _j === void 0 ? void 0 : _j.events) !== null && _k !== void 0 ? _k : [])) {
            if (this.selectedValue !== undefined) {
                if (this.subType === 'date-range' && this.selectedValue.length !== 2) {
                    continue;
                }
                let value = this.selectedValue;
                if (GTSLib.isArray(value) && this.type === 'input:multi-cb' && this.checkBoxes && !((_l = this.innerOptions.input) === null || _l === void 0 ? void 0 : _l.showFilter)) {
                    value = value.filter((v) => { var _a; return new RegExp(`.*${((_a = this.filter) !== null && _a !== void 0 ? _a : '')}.*`, 'gi').test(v); });
                }
                if (e.selector) {
                    if (!e.value) {
                        e.value = {};
                    }
                    e.value[e.selector] = value;
                }
                else {
                    e.value = value;
                }
                if (this.subType === 'number') {
                    e.value[e.selector] = parseFloat(e.value[e.selector]);
                }
                if (valid) {
                    (_m = this.LOG) === null || _m === void 0 ? void 0 : _m.debug(['handleClick', 'emit'], { discoveryEvent: e, subtype: this.subType }, value);
                    this.discoveryEvent.emit(Object.assign(Object.assign({}, e), { source: this.el.id }));
                }
                else {
                    (_o = this.LOG) === null || _o === void 0 ? void 0 : _o.debug(['handleClick', 'emit'], 'Invalid value');
                }
            }
        }
    }
    ;
    generateStyle(styles) {
        var _a, _b;
        this.innerStyles = Utils.clone(Object.assign(Object.assign(Object.assign({}, this.innerStyles), styles), (_a = this.innerOptions.customStyles) !== null && _a !== void 0 ? _a : {}));
        return Object.keys((_b = this.innerStyles) !== null && _b !== void 0 ? _b : {}).map(k => `${k} { ${this.innerStyles[k]} }`).join('\n');
    }
    handleSelect(e) {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        if (this.selectedValue !== ((_b = (_a = e === null || e === void 0 ? void 0 : e.target) === null || _a === void 0 ? void 0 : _a.value) !== null && _b !== void 0 ? _b : e === null || e === void 0 ? void 0 : e.detail)) {
            this.selectedValue = (_d = (_c = e === null || e === void 0 ? void 0 : e.target) === null || _c === void 0 ? void 0 : _c.value) !== null && _d !== void 0 ? _d : e === null || e === void 0 ? void 0 : e.detail;
            if (this.subType === 'chips-autocomplete' || this.subType === 'chips') {
                this.selectedValue = e.detail;
            }
            if (this.subType === 'multi' && ((_e = e.target) === null || _e === void 0 ? void 0 : _e.options)) {
                this.selectedValue = Array.from(e.target.options)
                    .filter((o) => !!o.selected)
                    .map((o) => o.value);
            }
            if (this.subType === 'multi-cb' && this.checkBoxes) {
                if ((_g = (_f = this.innerOptions) === null || _f === void 0 ? void 0 : _f.input) === null || _g === void 0 ? void 0 : _g.fuzzySearch) {
                    for (const o of this.initialValues) {
                        if (o.v == this.selectedValue) {
                            o.checked = e.target.checked;
                            break;
                        }
                    }
                    this.selectedValue = this.initialValues.filter(o => o.checked).map(o => o.v);
                }
                else {
                    this.selectedValue = Array.from(this.checkBoxes.querySelectorAll('input[type="checkbox"]'))
                        .filter((o) => o.checked)
                        .map((o) => o.value);
                }
            }
            if (this.subType !== 'file' && !((_h = this.innerOptions.input) === null || _h === void 0 ? void 0 : _h.showButton) && this.selectedValue !== undefined) {
                this.handleClick();
            }
            else if (['date', 'date-range'].includes(this.subType) && this.selectedValue !== undefined) {
                this.handleClick();
            }
        }
    }
    async readText(event) {
        var _a;
        const file = event.target.files.item(0);
        const text = await this.toBase64(file);
        this.LOG.debug(['readText'], { file, text });
        this.selectedValue = await this.toBase64(file);
        if (!((_a = this.innerOptions.input) === null || _a === void 0 ? void 0 : _a.showButton)) {
            this.handleClick();
        }
        event.target.value = '';
    }
    toBase64(file) {
        return new Promise((resolve, reject) => {
            const reader = new FileReader();
            reader.readAsDataURL(file);
            reader.onload = () => resolve(reader.result);
            reader.onerror = reject;
        });
    }
    ;
    parseResult() {
        var _a, _b, _c, _d, _e, _f, _g, _h;
        const data = this.innerResult.data !== undefined ? this.innerResult.data : '';
        this.LOG.debug(['parseResult', 'innerOptions'], this.innerOptions);
        const btnLabel = ((_a = this.innerOptions.button) !== null && _a !== void 0 ? _a : { label: 'Ok' }).label;
        const dm = (_c = ((_b = this.result) !== null && _b !== void 0 ? _b : {
            globalParams: {
                button: { label: btnLabel },
            },
        }).globalParams) !== null && _c !== void 0 ? _c : { button: { label: btnLabel } };
        this.label = (dm.button || { label: btnLabel }).label;
        switch (this.subType) {
            case 'text':
            case 'textarea':
            case 'secret':
                if (GTSLib.isArray(data) && !!data[0]) {
                    this.value = data[0].toString();
                }
                else {
                    this.value = data.toString();
                }
                this.selectedValue = this.value;
                break;
            case 'number':
                if (GTSLib.isArray(data) && data[0] !== undefined) {
                    this.value = parseFloat(data[0].toString());
                }
                else {
                    this.value = parseFloat(data.toString());
                }
                this.selectedValue = this.value;
                break;
            case 'date':
                if (GTSLib.isArray(data) && data[0] !== undefined) {
                    this.value = [data[0]];
                }
                else {
                    this.value = [data];
                }
                this.selectedValue = this.value[0];
                break;
            case 'date-range':
                if (GTSLib.isArray(data) && data.length >= 2) {
                    this.value = data.sort();
                }
                this.selectedValue = this.value;
                break;
            case 'slider':
                this.innerOptions.input = (_d = this.innerOptions.input) !== null && _d !== void 0 ? _d : {};
                this.innerOptions.input.value = (_e = this.innerOptions.input.value) !== null && _e !== void 0 ? _e : data;
                this.value = ((_g = (_f = this.innerOptions) === null || _f === void 0 ? void 0 : _f.input) === null || _g === void 0 ? void 0 : _g.value) === undefined ? 0 : this.innerOptions.input.value;
                this.selectedValue = this.value;
                this.innerOptions = Utils.clone(this.innerOptions);
                break;
            case 'list':
            case 'multi':
            case 'multi-cb':
            case 'autocomplete':
            case 'chips':
            case 'chips-autocomplete':
                if (this.checkBoxes) {
                    Array.from(this.checkBoxes.querySelectorAll('input[type="checkbox"]'))
                        .filter((o) => o.checked)
                        .forEach((o) => o.checked = false);
                }
                this.values = [];
                if (GTSLib.isArray(data)) {
                    this.values = [...data].filter(d => d !== '');
                }
                else {
                    this.values = [data.toString()].filter(d => d !== '');
                }
                if (typeof this.values[0] === 'string' || typeof this.values[0] === 'number') {
                    this.values = this.values.map(s => ({ k: s, v: s, h: false, id: v4().replaceAll('-', '') }));
                }
                let index = 0;
                if (((_h = this.innerOptions.input) !== null && _h !== void 0 ? _h : {}).value) {
                    index = this.values.map(o => o.v).indexOf((this.innerOptions.input || {}).value);
                }
                if (this.inputField) {
                    this.inputField.selectedIndex = index;
                }
                this.initialValues = [...this.values]; // keep a copy, fuzzy selection will break the list, need to save the original order.
                setTimeout(() => {
                    var _a, _b, _c, _d, _e, _f, _g, _h;
                    let value = (_b = (_a = this.innerOptions) === null || _a === void 0 ? void 0 : _a.input) === null || _b === void 0 ? void 0 : _b.value;
                    if (this.subType === 'multi' || this.subType === 'multi-cb' || this.subType === 'chips' || this.subType === 'chips-autocomplete') {
                        value = value !== null && value !== void 0 ? value : [];
                        if (!GTSLib.isArray(value)) {
                            value = [value];
                        }
                    }
                    if (this.subType !== 'autocomplete' && this.subType !== 'list') {
                        this.value = [...value];
                    }
                    else {
                        this.value = ((_d = (_c = this.innerOptions) === null || _c === void 0 ? void 0 : _c.input) === null || _d === void 0 ? void 0 : _d.value) !== undefined ? (_f = (_e = this.innerOptions) === null || _e === void 0 ? void 0 : _e.input) === null || _f === void 0 ? void 0 : _f.value : '';
                    }
                    if (this.subType === 'multi-cb' && this.checkBoxes) {
                        if ((_h = (_g = this.innerOptions) === null || _g === void 0 ? void 0 : _g.input) === null || _h === void 0 ? void 0 : _h.fuzzySearch) {
                            this.initialValues.map(o => o.checked = this.value.includes(o.v));
                        }
                        else {
                            Array.from(this.checkBoxes.querySelectorAll('input[type="checkbox"]'))
                                .forEach((o) => o.checked = this.value.includes(o.value));
                        }
                    }
                    if (this.selectedValue !== undefined && this.selectedValue !== this.oldValue) {
                        this.handleSelect({ detail: this.selectedValue });
                        this.oldValue = Utils.clone(this.selectedValue);
                    }
                    this.selectedValue = Utils.clone(this.value);
                });
                if (this.subType === 'autocomplete' && this.autoCompleteJS) {
                    this.autoCompleteJS.data = {
                        src: this.values,
                        keys: 'v',
                        filter: (list) => list.filter(item => {
                            var _a, _b;
                            if ('value' in this.inputField) {
                                const inputValue = ((_a = this.innerOptions.input) === null || _a === void 0 ? void 0 : _a.caseSensitive) ? this.inputField.value : this.inputField.value.toLowerCase();
                                const itemValue = ((_b = this.innerOptions.input) === null || _b === void 0 ? void 0 : _b.caseSensitive) ? item.value.v : item.value.v.toLowerCase();
                                if (itemValue.startsWith(inputValue)) {
                                    return item.value;
                                }
                            }
                        }),
                    };
                }
                break;
            default:
                return '';
        }
    }
    selectAll(e) {
        var _a, _b;
        if (this.type === 'input:multi-cb' && this.checkBoxes) {
            Array.from(this.checkBoxes.querySelectorAll('input[type="checkbox"]'))
                .filter((o) => !o.checked)
                .forEach((o) => o.checked = true);
            if ((_b = (_a = this.innerOptions) === null || _a === void 0 ? void 0 : _a.input) === null || _b === void 0 ? void 0 : _b.fuzzySearch) {
                this.initialValues.map(o => o.checked = true);
            }
            this.handleSelect(e);
        }
    }
    selectNone(e) {
        var _a, _b;
        if (this.type === 'input:multi-cb' && this.checkBoxes) {
            Array.from(this.checkBoxes.querySelectorAll('input[type="checkbox"]'))
                .filter((o) => o.checked)
                .forEach((o) => o.checked = false);
            if ((_b = (_a = this.innerOptions) === null || _a === void 0 ? void 0 : _a.input) === null || _b === void 0 ? void 0 : _b.fuzzySearch) {
                this.initialValues.map(o => o.checked = false);
            }
            this.handleSelect(e);
        }
    }
    handleFilter(e) {
        var _a, _b, _c, _d;
        e.stopPropagation();
        if (this.type === 'input:multi-cb' && this.checkBoxes) {
            this.filter = (_b = (_a = e.target.value) !== null && _a !== void 0 ? _a : e.detail) !== null && _b !== void 0 ? _b : '';
            if ((_d = (_c = this.innerOptions) === null || _c === void 0 ? void 0 : _c.input) === null || _d === void 0 ? void 0 : _d.fuzzySearch) {
                if (this.filter == '') {
                    this.values = this.initialValues;
                }
                else {
                    let r = fuzzysort.go(this.filter, this.initialValues, { key: 'v' }).toSorted((a, b) => b.score - a.score).map(r => r.obj);
                    r.push(...this.initialValues);
                    this.values = r;
                }
            }
            else {
                this.values = this.values.map(v => (Object.assign(Object.assign({}, v), { h: !new RegExp(`.*${this.filter}.*`, 'gi').test(v.v) })));
            }
        }
    }
    handleAutoComplete(input) {
        var _a, _b;
        if (this.subType === 'chips-autocomplete') {
            if ((_b = (_a = this.innerOptions) === null || _a === void 0 ? void 0 : _a.input) === null || _b === void 0 ? void 0 : _b.fuzzySearch) {
                return fuzzysort.go(input, this.values, { key: 'v' }).toSorted((a, b) => b.score - a.score);
            }
            else {
                return this.values
                    .filter(v => { var _a; return v.k.match(new RegExp(input, ((_a = this.innerOptions.input) === null || _a === void 0 ? void 0 : _a.caseSensitive) ? 'g' : 'gi')); })
                    .map(v => v.k);
            }
        }
        else {
            return [];
        }
    }
    handleContains(input) {
        var _a;
        if (this.subType === 'chips-autocomplete') {
            return this.values
                .map(v => { var _a; return ((_a = this.innerOptions.input) === null || _a === void 0 ? void 0 : _a.caseSensitive) ? v.k.toLowerCase() : v.k; })
                .includes(((_a = this.innerOptions.input) === null || _a === void 0 ? void 0 : _a.caseSensitive) ? input.toLowerCase() : input);
        }
        else {
            return false;
        }
    }
    getClass() {
        var _a, _b;
        return `discovery-input${((_b = (_a = this.innerOptions) === null || _a === void 0 ? void 0 : _a.input) === null || _b === void 0 ? void 0 : _b.validation) ? ' validation' : ''}`;
    }
    getInput() {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39, _40, _41, _42, _43, _44, _45, _46, _47, _48, _49, _50;
        switch (this.subType) {
            case 'text':
                return h("input", { type: "text", class: this.getClass(), value: this.value, onInput: e => this.handleSelect(e), required: (_b = (_a = this.innerOptions) === null || _a === void 0 ? void 0 : _a.input) === null || _b === void 0 ? void 0 : _b.validation, minLength: (_d = (_c = this.innerOptions) === null || _c === void 0 ? void 0 : _c.input) === null || _d === void 0 ? void 0 : _d.min, maxLength: (_f = (_e = this.innerOptions) === null || _e === void 0 ? void 0 : _e.input) === null || _f === void 0 ? void 0 : _f.max, disabled: (_h = (_g = this.innerOptions) === null || _g === void 0 ? void 0 : _g.input) === null || _h === void 0 ? void 0 : _h.disabled, ref: el => this.inputField = el });
            case 'number':
                return [
                    h("input", { type: "number", class: this.getClass(), value: this.value.toString(), onInput: e => this.handleSelect(e), ref: el => this.inputField = el, min: (_k = (_j = this.innerOptions) === null || _j === void 0 ? void 0 : _j.input) === null || _k === void 0 ? void 0 : _k.min, max: (_m = (_l = this.innerOptions) === null || _l === void 0 ? void 0 : _l.input) === null || _m === void 0 ? void 0 : _m.max, required: (_p = (_o = this.innerOptions) === null || _o === void 0 ? void 0 : _o.input) === null || _p === void 0 ? void 0 : _p.validation, disabled: (_r = (_q = this.innerOptions) === null || _q === void 0 ? void 0 : _q.input) === null || _r === void 0 ? void 0 : _r.disabled, step: (_u = (_t = (_s = this.innerOptions) === null || _s === void 0 ? void 0 : _s.input) === null || _t === void 0 ? void 0 : _t.step) !== null && _u !== void 0 ? _u : 'any' }),
                    h("span", { class: "validity" })
                ];
            case 'file':
                return h("input", { type: "file", class: this.getClass(), accept: (_x = (_w = (_v = this.innerOptions) === null || _v === void 0 ? void 0 : _v.input) === null || _w === void 0 ? void 0 : _w.accept) !== null && _x !== void 0 ? _x : '*/*', required: (_z = (_y = this.innerOptions) === null || _y === void 0 ? void 0 : _y.input) === null || _z === void 0 ? void 0 : _z.validation, onChange: e => void this.readText(e), disabled: (_1 = (_0 = this.innerOptions) === null || _0 === void 0 ? void 0 : _0.input) === null || _1 === void 0 ? void 0 : _1.disabled, ref: el => this.inputField = el });
            case 'textarea':
                return h("textarea", { class: this.getClass(), value: this.value, onInput: e => this.handleSelect(e), required: (_3 = (_2 = this.innerOptions) === null || _2 === void 0 ? void 0 : _2.input) === null || _3 === void 0 ? void 0 : _3.validation, disabled: (_5 = (_4 = this.innerOptions) === null || _4 === void 0 ? void 0 : _4.input) === null || _5 === void 0 ? void 0 : _5.disabled, ref: el => this.inputField = el });
            case 'secret':
                return h("input", { type: "password", class: this.getClass(), value: this.value, onInput: e => this.handleSelect(e), required: (_7 = (_6 = this.innerOptions) === null || _6 === void 0 ? void 0 : _6.input) === null || _7 === void 0 ? void 0 : _7.validation, disabled: (_9 = (_8 = this.innerOptions) === null || _8 === void 0 ? void 0 : _8.input) === null || _9 === void 0 ? void 0 : _9.disabled, ref: el => this.inputField = el });
            case 'date':
            case 'date-range':
                return h("discovery-input-date-range", { dateRange: this.value, onValueChanged: e => this.handleSelect(e), options: this.innerOptions, required: (_11 = (_10 = this.innerOptions) === null || _10 === void 0 ? void 0 : _10.input) === null || _11 === void 0 ? void 0 : _11.validation, disabled: (_13 = (_12 = this.innerOptions) === null || _12 === void 0 ? void 0 : _12.input) === null || _13 === void 0 ? void 0 : _13.disabled });
            case 'autocomplete':
                return h("input", { type: "text", class: this.getClass(), required: (_15 = (_14 = this.innerOptions) === null || _14 === void 0 ? void 0 : _14.input) === null || _15 === void 0 ? void 0 : _15.validation, value: this.value, disabled: (_17 = (_16 = this.innerOptions) === null || _16 === void 0 ? void 0 : _16.input) === null || _17 === void 0 ? void 0 : _17.disabled, ref: el => this.inputField = el });
            case 'slider':
                return h("div", { class: "slider-wrapper", ref: el => this.pngWrapper = el }, h("discovery-slider", { options: this.innerOptions, onValueChanged: e => this.handleSelect(e), debug: this.debug, disabled: (_19 = (_18 = this.innerOptions) === null || _18 === void 0 ? void 0 : _18.input) === null || _19 === void 0 ? void 0 : _19.disabled, ref: el => this.inputField = el }));
            case 'list':
                return h("select", { class: this.getClass(), onInput: e => this.handleSelect(e), required: (_21 = (_20 = this.innerOptions) === null || _20 === void 0 ? void 0 : _20.input) === null || _21 === void 0 ? void 0 : _21.validation, disabled: (_23 = (_22 = this.innerOptions) === null || _22 === void 0 ? void 0 : _22.input) === null || _23 === void 0 ? void 0 : _23.disabled, ref: el => this.inputField = el }, this.values.map(v => (h("option", { value: v.k, selected: this.value === v.k }, v.v))));
            case 'multi':
                return h("select", { class: this.getClass(), onInput: e => this.handleSelect(e), multiple: true, required: (_25 = (_24 = this.innerOptions) === null || _24 === void 0 ? void 0 : _24.input) === null || _25 === void 0 ? void 0 : _25.validation, disabled: (_27 = (_26 = this.innerOptions) === null || _26 === void 0 ? void 0 : _26.input) === null || _27 === void 0 ? void 0 : _27.disabled, ref: el => this.inputField = el }, this.values.map(v => (h("option", { value: v.k, selected: (this.value || []).includes(v.k) }, v.v))));
            case 'multi-cb':
                return h("div", { class: "multi-cb-wrapper", ref: el => this.pngWrapper = el }, h("div", { class: "multi-cb-layout" }, ((_28 = this.innerOptions.input) === null || _28 === void 0 ? void 0 : _28.showFilter)
                    ? h("input", { type: "text", class: this.getClass(), onKeyUp: e => this.handleFilter(e) })
                    : '', h("div", { class: "multi-cb-list-wrapper", ref: el => this.checkBoxes = el }, this.values.map(v => {
                    var _a, _b, _c, _d, _e;
                    return (h("div", { class: { 'multi-cb-item-wrapper': true, hidden: v.h } }, h("input", { type: "checkbox", value: v.k, id: v.id, checked: ((_b = (_a = this.innerOptions) === null || _a === void 0 ? void 0 : _a.input) === null || _b === void 0 ? void 0 : _b.fuzzySearch) ? v.checked : ((_c = this.value) !== null && _c !== void 0 ? _c : []).includes(v.k), onInput: e => this.handleSelect(e), disabled: (_e = (_d = this.innerOptions) === null || _d === void 0 ? void 0 : _d.input) === null || _e === void 0 ? void 0 : _e.disabled, name: v.v }), h("label", { htmlFor: v.id }, v.v)));
                }))), h("div", { class: "multi-cb-buttons-wrapper" }, h("div", null, h("button", { class: "discovery-btn secondary", type: "button", disabled: (_30 = (_29 = this.innerOptions) === null || _29 === void 0 ? void 0 : _29.input) === null || _30 === void 0 ? void 0 : _30.disabled, onClick: e => this.selectAll(e) }, (_33 = (_32 = (_31 = this.innerOptions) === null || _31 === void 0 ? void 0 : _31.input) === null || _32 === void 0 ? void 0 : _32.allLabel) !== null && _33 !== void 0 ? _33 : 'All'), h("button", { class: "discovery-btn secondary", type: "button", disabled: (_35 = (_34 = this.innerOptions) === null || _34 === void 0 ? void 0 : _34.input) === null || _35 === void 0 ? void 0 : _35.disabled, onClick: e => this.selectNone(e) }, (_38 = (_37 = (_36 = this.innerOptions) === null || _36 === void 0 ? void 0 : _36.input) === null || _37 === void 0 ? void 0 : _37.noneLabel) !== null && _38 !== void 0 ? _38 : 'None')), ((_39 = this.innerOptions.input) === null || _39 === void 0 ? void 0 : _39.showButton) ?
                    h("div", { class: "discovery-input-btn-wrapper" }, h("button", { class: "discovery-btn", disabled: ((_41 = (_40 = this.innerOptions) === null || _40 === void 0 ? void 0 : _40.input) === null || _41 === void 0 ? void 0 : _41.disabled) || this.disabled, type: "button", onClick: () => this.handleClickRT(), innerHTML: this.label })) : ''));
            case 'chips':
            case 'chips-autocomplete':
                return h("div", { class: { 'chips-input-wrapper': true, 'disabled': (_43 = (_42 = this.innerOptions) === null || _42 === void 0 ? void 0 : _42.input) === null || _43 === void 0 ? void 0 : _43.disabled } }, h("discovery-input-chips", { ref: el => this.inputField = el, chips: this.value, autocomplete: this.handleAutoComplete.bind(this), containsFn: this.handleContains.bind(this), disabled: (_45 = (_44 = this.innerOptions) === null || _44 === void 0 ? void 0 : _44.input) === null || _45 === void 0 ? void 0 : _45.disabled, fuzzy_search: (_47 = (_46 = this.innerOptions) === null || _46 === void 0 ? void 0 : _46.input) === null || _47 === void 0 ? void 0 : _47.fuzzySearch, chipDelimiters: (_49 = (_48 = this.innerOptions) === null || _48 === void 0 ? void 0 : _48.input) === null || _49 === void 0 ? void 0 : _49.chipDelimiters, onChipChange: e => this.handleSelect(e), constrain_input: !!((_50 = this.innerOptions.input) === null || _50 === void 0 ? void 0 : _50.onlyFromAutocomplete) }));
            default:
                return '';
        }
    }
    render() {
        var _a, _b, _c;
        return [
            h("style", { key: '909f7b2c20e35468c5b8952a2dc3083017e59f5a' }, this.generateStyle(this.innerStyle)),
            h("div", { key: '216c80a08e8a075026ead69e18bf87f2aee170e0', ref: el => this.root = el }, h("div", { key: '3c2c5822a4e9ad86e621549d50980fa678efb02c', class: 'discovery-input-wrapper type-' + this.subType }, this.getInput(), ((_a = this.innerOptions.input) === null || _a === void 0 ? void 0 : _a.showButton) && this.type !== 'input:multi-cb' ?
                h("div", { class: 'discovery-input-btn-wrapper ' + this.subType }, h("button", { class: "discovery-btn", disabled: ((_c = (_b = this.innerOptions) === null || _b === void 0 ? void 0 : _b.input) === null || _c === void 0 ? void 0 : _c.disabled) || this.disabled, type: "button", onClick: () => this.handleClickRT() }, this.label)) : '')),
        ];
    }
    get el() { return this; }
    static get watchers() { return {
        "result": ["updateRes"],
        "options": ["optionsUpdate"]
    }; }
    static get style() { return DiscoveryInputStyle0; }
}, [1, "discovery-input", {
        "result": [1],
        "type": [1],
        "options": [1],
        "width": [2],
        "height": [2],
        "debug": [4],
        "url": [1],
        "parsing": [32],
        "rendering": [32],
        "value": [32],
        "subType": [32],
        "innerStyle": [32],
        "innerResult": [32],
        "label": [32],
        "selectedValue": [32],
        "values": [32],
        "resize": [64],
        "export": [64]
    }, [[8, "discoveryEvent", "discoveryEventHandler"]], {
        "result": ["updateRes"],
        "options": ["optionsUpdate"]
    }]);
function defineCustomElement() {
    if (typeof customElements === "undefined") {
        return;
    }
    const components = ["discovery-input", "discovery-input-chips", "discovery-input-chips-chip", "discovery-input-date-range", "discovery-slider"];
    components.forEach(tagName => { switch (tagName) {
        case "discovery-input":
            if (!customElements.get(tagName)) {
                customElements.define(tagName, DiscoveryInputComponent);
            }
            break;
        case "discovery-input-chips":
            if (!customElements.get(tagName)) {
                defineCustomElement$4();
            }
            break;
        case "discovery-input-chips-chip":
            if (!customElements.get(tagName)) {
                defineCustomElement$3();
            }
            break;
        case "discovery-input-date-range":
            if (!customElements.get(tagName)) {
                defineCustomElement$2();
            }
            break;
        case "discovery-slider":
            if (!customElements.get(tagName)) {
                defineCustomElement$1();
            }
            break;
    } });
}

export { DiscoveryInputComponent as D, defineCustomElement as d };

//# sourceMappingURL=discovery-input2.js.map