import { L as Logger } from './utils.js';
export { G as GTSLib, J as JsonLib, a as LangUtils, L as Logger, P as Param, U as Utils } from './utils.js';
export { getAssetPath, setAssetPath, setNonce, setPlatformOptions } from '@stencil/core/internal/client';
export { C as ColorLib, a as Colors, H as HeatMaps } from './color-lib.js';
export { M as MapLib, a as MapTypes } from './map-lib.js';
export { d as CHART_TYPES, C as ChartBounds, a as Dashboard, b as DataModel, D as Dataset, c as DiscoveryEvent, G as GTS, L as Label, M as MapParams, T as Tile } from './types.js';
export { P as PluginManager } from './PluginManager.js';

const packageJson = {
    version: '1.2.36',
    name: '@senx/discovery-widgets',
    description: 'Discovery Widgets Elements',
    author: 'SenX <contact@senx.io>',
    license: 'Apache-2.0',
    homepage: 'https://discovery.warp10.io/'
};

/*
 *   Copyright 2024 SenX S.A.S.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */
const appGlobalScript = () => {
    const LOG = new Logger({ name: 'Discovery by SenX' });
    LOG.info(['Version'], packageJson.version);
    LOG.info(['Info'], packageJson.homepage);
};

const globalScripts = appGlobalScript;

/*
 *   Copyright 2022-2025 SenX S.A.S.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */
class PluginDef {
    constructor(def) {
        this.type = def.type;
        this.name = def.name;
        this.tag = def.tag;
        this.author = def.author;
        this.description = def.description;
        this.version = def.version;
        this.scriptWrapper = def.scriptWrapper;
    }
    toString() {
        return `${this.name}:${this.version} by ${this.author}`;
    }
}

/*
 *   Copyright 2022  SenX S.A.S.
 *
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */
window.global = window;

globalScripts();

export { PluginDef };

//# sourceMappingURL=index.js.map