import { EventEmitter } from '../../stencil-public-runtime';
import { ChartType, DataModel, DiscoveryEvent } from '../../model/types';
import { Param } from '../../model/param';
import { EChartsOption } from 'echarts';
import _ from 'lodash';
export declare class DiscoveryAnnotation {
    result: DataModel | string;
    type: ChartType;
    options: Param | string;
    width: number;
    height: number;
    debug: boolean;
    unit: string;
    url: string;
    language: 'warpscript' | 'flows';
    vars: string;
    el: HTMLElement;
    draw: EventEmitter<void>;
    dataZoom: EventEmitter<{
        start?: number;
        end?: number;
        min?: number;
        max?: number;
        type?: string;
    }>;
    dataPointOver: EventEmitter;
    dataPointSelected: EventEmitter;
    timeBounds: EventEmitter;
    leftMarginComputed: EventEmitter<number>;
    poi: EventEmitter;
    discoveryEvent: EventEmitter<DiscoveryEvent>;
    execError: EventEmitter;
    parsing: boolean;
    rendering: boolean;
    chartOpts: EChartsOption;
    expanded: boolean;
    innerOptions: Param;
    private graph;
    private defOptions;
    private LOG;
    private displayExpander;
    private myChart;
    private divider;
    private hasFocus;
    private gtsList;
    private focusDate;
    private bounds;
    private leftMargin;
    private MAX_MARGIN;
    private pois;
    private innerVars;
    private static renderItem;
    varsUpdate(newValue: any, oldValue: any): void;
    updateRes(): void;
    optionsUpdate(newValue: any, oldValue: any): void;
    resize(): Promise<void>;
    show(regexp: string): Promise<void>;
    hide(regexp: string): Promise<void>;
    hideById(id: number | string): Promise<void>;
    showById(id: number | string): Promise<void>;
    componentWillLoad(): void;
    private setOpts;
    convert(data: DataModel): EChartsOption;
    private zoomHandler;
    restoreZoomHandler: _.DebouncedFuncLeading<() => void>;
    componentDidLoad(): void;
    setZoom(dataZoom: {
        start?: number;
        end?: number;
        type?: string;
    }): Promise<void>;
    export(type?: 'png' | 'svg'): Promise<string>;
    setFocus(regexp: string, ts: number): Promise<void>;
    unFocus(): Promise<void>;
    private hideMarkers;
    render(): any;
    private toggle;
}
