import { EventEmitter } from '../../stencil-public-runtime';
import { ChartType, DataModel, DiscoveryEvent } from '../../model/types';
import { Param } from '../../model/param';
import * as echarts from 'echarts';
export declare class DiscoveryBarPolarComponent {
    result: DataModel | string;
    type: ChartType;
    options: Param | string;
    width: number;
    height: number;
    debug: boolean;
    unit: string;
    url: string;
    language: 'warpscript' | 'flows';
    vars: string;
    el: HTMLElement;
    draw: EventEmitter<void>;
    dataZoom: EventEmitter<{
        start?: number;
        end?: number;
        min?: number;
        max?: number;
        type?: string;
    }>;
    leftMarginComputed: EventEmitter<number>;
    dataPointOver: EventEmitter;
    dataPointSelected: EventEmitter;
    timeBounds: EventEmitter;
    discoveryEvent: EventEmitter<DiscoveryEvent>;
    execError: EventEmitter;
    parsing: boolean;
    rendering: boolean;
    innerOptions: Param;
    private graph;
    private chartOpts;
    private defOptions;
    private LOG;
    private divider;
    private myChart;
    private leftMargin;
    private hasFocus;
    private bounds;
    private isGTS;
    private zoom;
    private categories;
    private innerWidth;
    private innerHeight;
    private innerVars;
    varsUpdate(newValue: any, oldValue: any): void;
    updateRes(): void;
    optionsUpdate(newValue: any, oldValue: any): void;
    resize(): Promise<void>;
    setZoom(dataZoom: {
        start?: number;
        end?: number;
    }): Promise<void>;
    componentWillLoad(): void;
    private setOpts;
    private getCommonSeriesParam;
    convert(data: DataModel): echarts.EChartsOption;
    private zoomHandler;
    componentDidLoad(): void;
    export(type?: 'png' | 'svg'): Promise<string>;
    show(regexp: string): Promise<void>;
    hide(regexp: string): Promise<void>;
    hideById(id: number | string): Promise<void>;
    showById(id: number | string): Promise<void>;
    setFocus(regexp: string, ts: number, value?: number): Promise<void>;
    unFocus(): Promise<void>;
    render(): any;
}
