import { EventEmitter } from '../../stencil-public-runtime';
import { ChartType, DataModel, DiscoveryEvent } from '../../model/types';
import { Param } from '../../model/param';
import * as echarts from 'echarts';
export declare class DiscoveryCalendar {
    result: DataModel | string;
    type: ChartType;
    options: Param | string;
    width: number;
    height: number;
    debug: boolean;
    unit: string;
    url: string;
    language: 'warpscript' | 'flows';
    vars: string;
    el: HTMLElement;
    draw: EventEmitter<void>;
    dataPointOver: EventEmitter;
    dataPointSelected: EventEmitter;
    discoveryEvent: EventEmitter<DiscoveryEvent>;
    execError: EventEmitter;
    parsing: boolean;
    rendering: boolean;
    innerOptions: Param;
    private graph;
    private chartOpts;
    private defOptions;
    private LOG;
    private divider;
    private myChart;
    private CAL_SIZE;
    private innerWidth;
    private innerHeight;
    private innerVars;
    varsUpdate(newValue: any, oldValue: any): void;
    updateType(newValue: string, oldValue: string): void;
    updateRes(): void;
    optionsUpdate(newValue: any, oldValue: any): void;
    resize(): Promise<void>;
    show(regexp: string): Promise<void>;
    hide(regexp: string): Promise<void>;
    hideById(id: number | string): Promise<void>;
    showById(id: number | string): Promise<void>;
    componentWillLoad(): void;
    convert(data: DataModel): echarts.EChartsOption;
    export(type?: 'png' | 'svg'): Promise<string>;
    private setOpts;
    componentDidLoad(): void;
    render(): any;
}
