import { EventEmitter } from '../../stencil-public-runtime';
import { Param } from '../../model/param';
import { Dashboard, DataModel, DiscoveryEvent, Tile } from '../../model/types';
export declare class DiscoveryDashboardComponent {
    url: string;
    dashboardTitle: string;
    data: Dashboard | string;
    warpscript: string;
    options: Param | string;
    debug: boolean;
    autoRefresh: number;
    cellHeight: number;
    cols: number;
    type: 'scada' | 'dashboard' | 'flex';
    vars: any;
    inTile: boolean;
    statusHeaders: EventEmitter<string[]>;
    statusError: EventEmitter;
    rendered: EventEmitter<void>;
    el: HTMLElement;
    width: number;
    height: number;
    result: Dashboard;
    modalContent: Tile | Dashboard;
    headers: any;
    loaded: boolean;
    start: number;
    innerStyle: {
        [k: string]: string;
    };
    audioFile: string;
    title: string;
    description: string;
    types: any;
    hasError: boolean;
    private LOG;
    private ws;
    private timer;
    private modal;
    private innerType;
    private scadaHeight;
    private innerStyles;
    private innerOptions;
    private tiles;
    private renderedTiles;
    private done;
    private dash;
    private innerVars;
    private componentId;
    private eventState;
    private refreshTimer;
    private firstLoad;
    private errorMessage;
    optionsUpdate(newValue: any, oldValue: any): void;
    dataUpdate(newValue: string, oldValue: string): void;
    varsUpdate(newValue: string, oldValue: string): void;
    warpscriptUpdate(newValue: string, oldValue: string): void;
    discoveryEventHandler(event: CustomEvent<DiscoveryEvent>): Promise<void>;
    componentWillLoad(): void;
    componentDidLoad(): void;
    disconnectedCallback(): void;
    getPDF(save?: boolean, output?: string, a4?: boolean): Promise<any>;
    getVars(): Promise<any>;
    getDashboardStructure(): Promise<Dashboard>;
    exec(): void;
    private sanitizeTiles;
    private parseResult;
    private processMacroTiles;
    private processResult;
    static merge(options: Param | string, tileOptions: Param): any;
    static mergeVars(vars: any[] | string[]): any;
    static sanitize(data: any): string | DataModel;
    private getType;
    private getRowSpan;
    private setActualType;
    private getRendering;
    render(): any;
    private generateStyle;
    private addTile;
    private getHeight;
}
