import { EventEmitter } from '../../stencil-public-runtime';
import { ChartType, DataModel } from '../../model/types';
import { Param } from '../../model/param';
import { EChartsOption } from 'echarts';
export declare class DiscoveryGauge {
    result: DataModel | string;
    type: ChartType;
    options: Param | string;
    width: number;
    height: number;
    debug: boolean;
    unit: string;
    el: HTMLElement;
    draw: EventEmitter<void>;
    dataPointOver: EventEmitter;
    dataPointSelected: EventEmitter;
    parsing: boolean;
    rendering: boolean;
    innerOptions: Param;
    private graph;
    private chartOpts;
    private defOptions;
    private LOG;
    private myChart;
    private innerWidth;
    private innerHeight;
    updateRes(): void;
    optionsUpdate(newValue: any, oldValue: any): void;
    resize(): Promise<void>;
    show(regexp: string): Promise<void>;
    hide(regexp: string): Promise<void>;
    hideById(id: number | string): Promise<void>;
    showById(id: number | string): Promise<void>;
    componentWillLoad(): void;
    private setOpts;
    private getCommonSeriesParam;
    convert(data: DataModel): EChartsOption;
    autoFontSize(size: number): number;
    componentDidLoad(): void;
    export(type?: 'png' | 'svg'): Promise<string>;
    render(): any;
    private static getAngles;
}
