import { Moment } from 'moment';
import { DTPickerOptions } from './options';
export declare class DateRangePicker {
    private jq;
    private rangesLiElList;
    private readonly parentEl;
    private readonly element;
    private options;
    private isShowing;
    private readonly callback;
    private readonly rightCalendar;
    private readonly leftCalendar;
    private container;
    private timepicker;
    private startDate;
    private endDate;
    private oldStartDate;
    private oldEndDate;
    private chosenLabel;
    private outsideClickProxy;
    private moveProxy;
    private clickRangeProxy;
    private clickApplyProxy;
    private clickCancelProxy;
    private showProxy;
    private elementChangedProxy;
    private keydownProxy;
    private toggleProxy;
    private clickPrevProxy;
    private clickNextProxy;
    private clickDateProxy;
    private hoverDateProxy;
    private monthOrYearChangedProxy;
    private timeChangedProxy;
    constructor(element: string | HTMLInputElement, options: DTPickerOptions | null, cb: (_start: Moment, _end: Moment) => void);
    setStartDate(startDate: Moment): void;
    setEndDate(endDate: Moment): void;
    isInvalidDate(_a: any): boolean;
    isCustomDate(_a: any): boolean;
    updateView(): void;
    updateMonthsInView(): void;
    updateCalendars(): void;
    renderCalendar(side: string): void;
    renderTimePicker(side: string): void;
    updateFormInputs(): void;
    move(_e?: Event): void;
    show(_e?: Event): void;
    hide(_e?: Event): void;
    toggle(e?: Event): void;
    outsideClick(e: MouseEvent): void;
    showCalendars(): void;
    hideCalendars(): void;
    clickRange(e: MouseEvent): void;
    clickPrev(e: MouseEvent): void;
    clickNext(e: MouseEvent): void;
    hoverDate(e: MouseEvent): void;
    clickDate(e: MouseEvent): void;
    calculateChosenLabel(): void;
    clickApply(e: MouseEvent): void;
    clickCancel(e: MouseEvent): void;
    monthOrYearChanged(e: Event): void;
    timeChanged(e: Event): void;
    elementChanged(_e?: Event): void;
    keydown(e: KeyboardEvent): void;
    updateElement(): void;
    remove(): void;
    updateRanges(newRanges: any): void;
}
