import { EventEmitter } from '../../stencil-public-runtime';
import { EChartsOption } from 'echarts';
import { Param } from '../../model/param';
import { ChartType, DataModel, DiscoveryEvent } from '../../model/types';
import 'moment/min/locales.js';
export declare class DiscoveryLineComponent {
    result: DataModel | string;
    type: ChartType;
    options: Param | string;
    width: number;
    height: number;
    debug: boolean;
    unit: string;
    url: string;
    language: 'warpscript' | 'flows';
    vars: string;
    el: HTMLElement;
    draw: EventEmitter<void>;
    dataZoom: EventEmitter<{
        start?: number;
        end?: number;
        min?: number;
        max?: number;
        orientation?: string;
        type?: string;
    }>;
    dataZoomY: EventEmitter<{
        start?: number;
        end?: number;
        min?: number;
        max?: number;
        orientation?: string;
        type?: string;
    }>;
    leftMarginComputed: EventEmitter<number>;
    dataPointOver: EventEmitter;
    dataPointSelected: EventEmitter;
    poi: EventEmitter;
    timeBounds: EventEmitter;
    discoveryEvent: EventEmitter<DiscoveryEvent>;
    execError: EventEmitter;
    parsing: boolean;
    rendering: boolean;
    innerOptions: Param;
    private graph;
    private chartOpts;
    private defOptions;
    private LOG;
    private divider;
    private myChart;
    private leftMargin;
    private hasFocus;
    private bounds;
    private zoom;
    private pois;
    private innerWidth;
    private innerHeight;
    private zoomXInfo;
    private zoomYInfo;
    private innerVars;
    updateType(newValue: string, oldValue: string): void;
    updateRes(newValue: DataModel | string, oldValue: DataModel | string): void;
    optionsUpdate(newValue: any, oldValue: any): void;
    varsUpdate(newValue: any, oldValue: any): void;
    componentWillLoad(): void;
    setOpts(notMerge?: boolean): void;
    convert(data: DataModel): EChartsOption;
    private getYAxis;
    private getXAxis;
    static getStepShape(type: ChartType): "start" | "end";
    private zoomHandler;
    private zoomYHandler;
    componentDidLoad(): void;
    resize(): Promise<void>;
    setZoom(dataZoom: {
        start?: number;
        end?: number;
    }): Promise<void>;
    export(type?: 'png' | 'svg'): Promise<string>;
    show(regexp: string): Promise<void>;
    hide(regexp: string): Promise<void>;
    hideById(id: number | string): Promise<void>;
    showById(id: number | string): Promise<void>;
    setFocus(regexp: string, ts: number, value?: number): Promise<void>;
    unFocus(): Promise<void>;
    private hideMarkers;
    render(): any;
}
