import { EventEmitter } from '../../stencil-public-runtime';
import { ChartType, DataModel, DiscoveryEvent } from '../../model/types';
import { Param } from '../../model/param';
export declare class DiscoveryLinearGauge {
    result: DataModel | string;
    type: ChartType;
    options: Param | string;
    width: number;
    height: number;
    debug: boolean;
    unit: string;
    vars: string;
    el: HTMLElement;
    draw: EventEmitter<void>;
    dataPointOver: EventEmitter;
    parsing: boolean;
    rendering: boolean;
    innerOptions: Param;
    innerStyle: {
        [k: string]: string;
    };
    private innerVars;
    private root;
    private tooltip;
    private chartOpts;
    private defOptions;
    private LOG;
    private divider;
    private myChart;
    private dataStruct;
    private isVertical;
    private innerWidth;
    updateRes(): void;
    optionsUpdate(newValue: any, oldValue: any): void;
    varsUpdate(newValue: string, oldValue: string): void;
    discoveryEventHandler(event: CustomEvent<DiscoveryEvent>): void;
    resize(): Promise<void>;
    show(regexp: string): Promise<void>;
    hide(regexp: string): Promise<void>;
    hideById(id: number | string): Promise<void>;
    showById(id: number | string): Promise<void>;
    componentWillLoad(): void;
    convert(data: DataModel): void;
    componentDidLoad(): void;
    export(_type?: 'png' | 'svg'): Promise<string>;
    setMousePosition(e: MouseEvent): void;
    showTooltip(data: any): void;
    hideTooltip(): void;
    private generateStyle;
    render(): any[];
}
