import { EventEmitter } from '../../stencil-public-runtime';
import { ChartType, DataModel } from '../../model/types';
import { Param } from '../../model/param';
import 'leaflet-edgebuffer';
import 'leaflet.heat';
import 'leaflet.markercluster';
export declare class DiscoveryMapComponent {
    result: DataModel | string;
    type: ChartType;
    options: Param | string;
    width: number;
    height: number;
    debug: boolean;
    el: HTMLElement;
    draw: EventEmitter<void>;
    dataPointOver: EventEmitter;
    dataPointSelected: EventEmitter;
    geoBounds: EventEmitter<string>;
    poi: EventEmitter;
    parsing: boolean;
    toDisplay: string[];
    innerOptions: Param;
    private defOptions;
    private divider;
    private LOG;
    private mapElement;
    private map;
    private bounds;
    private currentZoom;
    private currentLat;
    private currentLong;
    private pathData;
    private positionData;
    private geoJson;
    private pathDataLayer;
    private positionDataLayer;
    private tileLayerGroup;
    private geoJsonLayer;
    private tilesLayer;
    private poiLayer;
    private mainLayer;
    private heatmapLayer;
    private shadowHeatmapLayer;
    private firstDraw;
    private mapOpts;
    private initial;
    private hidden;
    private popupTimeout;
    private markerOver;
    private markersRef;
    private tileLayers;
    private pois;
    updateRes(newValue: DataModel | string, oldValue: DataModel | string): void;
    optionsUpdate(newValue: any, oldValue: any): void;
    resize(): Promise<void>;
    export(_type?: 'png' | 'svg'): Promise<string>;
    show(regexp: string): Promise<void>;
    hide(regexp: string): Promise<void>;
    hideById(id: number): Promise<void>;
    showById(id: number | string): Promise<void>;
    componentWillLoad(): void;
    componentDidLoad(): void;
    drawMap(data: DataModel, isRefresh?: boolean, optionUpdate?: boolean): void;
    private icon;
    private getGTSDots;
    private updateGtsPath;
    private addPopup;
    setFocus(regexp: string, ts: number): Promise<void>;
    unFocus(): Promise<void>;
    private updatePositionArray;
    render(): any;
}
