import { EventEmitter } from '../../stencil-public-runtime';
import { ChartType, DataModel, DiscoveryEvent } from '../../model/types';
import { Param } from '../../model/param';
export declare class DiscoveryTileResultComponent {
    el: HTMLElement;
    result: DataModel | string;
    type: ChartType;
    start: number;
    options: Param | string;
    width: number;
    height: number;
    debug: boolean;
    unit: string;
    url: string;
    chartTitle: string;
    chartDescription: string;
    language: 'warpscript' | 'flows';
    vars: string;
    standalone: boolean;
    execTime: number;
    bgColor: string;
    fontColor: string;
    innerResult: DataModel | string;
    innerOptions: Param;
    innerStyle: {
        [k: string]: string;
    };
    innerType: ChartType;
    innerTitle: string;
    ready: boolean;
    discoveryEvent: EventEmitter<DiscoveryEvent>;
    draw: EventEmitter<void>;
    selfType: EventEmitter<ChartType>;
    execError: EventEmitter<any[]>;
    private LOG;
    private tileElem;
    private innerStyles;
    private tile;
    private innerVars;
    private componentId;
    updateType(newValue: string): void;
    updateRes(newValue: string): void;
    optionsUpdate(newValue: any, oldValue: string): void;
    varsUpdate(newValue: any, oldValue: any): void;
    discoveryEventHandler(event: CustomEvent<DiscoveryEvent>): void;
    onDrawHandler(): void;
    onLeftMarginComputed(event: CustomEvent): void;
    onTimeBounds(event: CustomEvent): void;
    componentWillLoad(): void;
    componentDidLoad(): void;
    disconnectedCallback(): void;
    handleZoom(event: CustomEvent<{
        start?: number;
        end?: number;
        type?: string;
    }>): void;
    handleDataPointOver(event: CustomEvent): void;
    handleDataSelected(event: CustomEvent): void;
    handlePoi(event: CustomEvent): void;
    handleGeoBounds(event: CustomEvent): void;
    getView(): any;
    resize(): Promise<void>;
    setZoom(dataZoom: {
        start?: number;
        end?: number;
        type?: string;
    }): Promise<void>;
    show(regexp: string): Promise<void>;
    showById(id: number): Promise<void>;
    hide(regexp: string): Promise<void>;
    hideById(id: number): Promise<void>;
    setFocus(regexp: string, ts: number, value?: number): Promise<void>;
    unFocus(): Promise<void>;
    export(type?: 'png' | 'svg'): Promise<{
        dataUrl: string;
        bgColor: string;
    }>;
    render(): any[];
    parseEvents(): Promise<void>;
    private parseResult;
    private generateStyle;
    private handleCSSColors;
    private handleExecError;
}
