import { EventEmitter } from '../../stencil-public-runtime';
import { ChartType, DiscoveryEvent } from '../../model/types';
import { Param } from '../../model/param';
export declare class DiscoveryTileComponent {
    url: string;
    chartTitle: string;
    chartDescription: string;
    script: string;
    type: ChartType;
    options: Param | string;
    language: 'warpscript' | 'flows';
    debug: boolean;
    unit: string;
    autoRefresh: number;
    vars: any;
    statusHeaders: EventEmitter<string[]>;
    statusError: EventEmitter;
    execResult: EventEmitter<string>;
    selfType: EventEmitter<ChartType>;
    draw: EventEmitter<void>;
    el: HTMLElement;
    loaded: boolean;
    result: string;
    width: number;
    height: number;
    showLoader: boolean;
    hasError: boolean;
    errorMessage: string;
    statusMessage: string;
    hiddenByWs: boolean;
    private LOG;
    private ws;
    private timer;
    private timerFadeOut;
    private innerVars;
    private innerOptions;
    private tileResult;
    private socket;
    private componentId;
    private firstExec;
    private headers;
    private start;
    private latestRequestTs;
    optionsUpdate(newValue: any, oldValue: any): Promise<void>;
    scriptUpdate(newValue: any, oldValue: any): Promise<void>;
    varsUpdate(newValue: string, oldValue: string): Promise<void>;
    discoveryEventHandler(event: CustomEvent<DiscoveryEvent>): Promise<void>;
    resize(): Promise<void>;
    show(regexp: string): Promise<void>;
    showById(id: number): Promise<void>;
    hide(regexp: string): Promise<void>;
    hideById(id: number): Promise<void>;
    setFocus(regexp: string, ts: number, value?: number): Promise<void>;
    unFocus(): Promise<void>;
    componentWillLoad(): void;
    componentDidLoad(): Promise<void>;
    disconnectedCallback(): void;
    export(type?: 'png' | 'svg'): Promise<{
        dataUrl: string;
        bgColor: string;
    }>;
    exec(refresh?: boolean): Promise<unknown>;
    setZoom(dataZoom: {
        start: number;
        end: number;
    }): Promise<void>;
    private handleSelfType;
    private displayError;
    render(): any;
}
