import { Param } from '../model/param';
export declare enum MapTypes {
    NONE = "NONE",
    DEFAULT = "DEFAULT",
    HOT = "HOT",
    TOPO = "TOPO",
    TOPO2 = "TOPO2",
    STADIA = "STADIA",
    STADIA_DARK = "STADIA_DARK",
    TONER = "TONER",
    TONER_LITE = "TONER_LITE",
    TERRAIN = "TERRAIN",
    ESRI = "ESRI",
    SATELLITE = "SATELLITE",
    OCEANS = "OCEANS",
    GRAY = "GRAY",
    GRAYSCALE = "GRAYSCALE",
    WATERCOLOR = "WATERCOLOR",
    CARTODB = "CARTODB",
    CARTODB_DARK = "CARTODB_DARK"
}
export declare class MapLib {
    static BASE_RADIUS: number;
    private static LOG;
    static mapTypes: any;
    static toLeafletMapPaths(data: {
        gts: any[];
        params: any[];
        globalParams: Param;
    }, hiddenData: {
        [key: string]: boolean;
    }, scheme: string): any[];
    static gtsToPath(gts: any): any[];
    private static extractCommonParameters;
    private static validateWeightedDotsPositionArray;
    static toLeafletMapPositionArray(data: {
        gts: any[];
        params: any[];
        globalParams: Param;
    }, hiddenData: {
        [key: string]: boolean;
    }, scheme: string): any[];
    private static validateWeightedColoredDotsPositionArray;
    static pathDataToLeaflet(pathData: any[]): any[];
    static toGeoJSON(data: {
        gts: any[];
        params: any[];
    }): any[];
    static updatePositionArrayToLeaflet(positionArray: any[]): any[];
}
